/************************************************************************************************
 * Copyright/Copyleft:
 *
 * For this source the LGPL Lesser General Public License,
 * published by the Free Software Foundation is valid.
 * It means:
 * 1) You can use this source without any restriction for any desired purpose.
 * 2) You can redistribute copies of this source to everybody.
 * 3) Every user of this source, also the user of redistribute copies
 *    with or without payment, must accept this license for further using.
 * 4) But the LPGL ist not appropriate for a whole software product,
 *    if this source is only a part of them. It means, the user
 *    must publish this part of source,
 *    but don't need to publish the whole source of the own product.
 * 5) You can study and modify (improve) this source
 *    for own using or for redistribution, but you have to license the
 *    modified sources likewise under this LGPL Lesser General Public License.
 *    You mustn't delete this Copyright/Copyleft inscription in this source file.
 *
 * This source may be used also with another licence, if the author 
 * and all other here named co-authors have agreed to this contract.
 * Especially a company can use a copy of this sources in its products without publishing.
 * The user should have a underwritten contract therefore.
 *
 * @author Hartmut Schorrig, Germany, Pinzberg, www.vishia.org
 *
 **copyright***************************************************************************************
 *
 * @content
 *
 * @author Hartmut Schorrig, Pinzberg, Germany
 *
 * @version 0.83
 *
 * @content: Implementation of BlockHeap-organization and allocation memory.
 *
 * @author JcHartmut www.vishia.org
 * @version 0.82
 * list of changes:
 * 2008-04-15: JcHartmut creation from older sources
 *
 ****************************************************************************/
//#include "CRuntimeJavalike.h"
//#include "ThreadJc.h"
#include "BlockHeapJc_internal.h"
#include "Jc/StringJc.h"
#include "Fwc/fw_LogMessage.h"
#include "OSAL/inc/os_time.h"
#include "Fwc/fw_Exception.h"

//#include <stdio.h>
//#include <stdlib.h>
#include <string.h>




#if defined(mBackRef_REF_ObjectJc)
  /**Definition of the methods setBackRef_ObjectJc and clearBackRef_ObjectJc inside.
    * It is possible that this file is not available in the user system.
    * Therefore do not include if not necessary.
  */
  //#include "ObjectrefJc.h"
#endif
//#include "ThreadJc.h"

#include "Fwc/fw_Exception.h"

typedef enum EBlockType_t
{
  kSizeSmallBlock_BlockHeap = 0x7e
, kReferencesStd_BlockHeap = 10
}EBlockType;


//BlockHeapJc* current_BlockHeapJc = null;



BlockHeapJc* current_sBlockHeapJc(ThCxt* _thCxt)
{ return _thCxt->blockHeap;
}

BlockHeapJc* theBlockHeapList = null;


BlockHeapJc* setCurrent_BlockHeapJc(BlockHeapJc* heap, ThCxt* _thCxt)
{ BlockHeapJc* last = _thCxt->blockHeap;
  _thCxt->blockHeap = heap;
  return last;
}


METHOD_C void addHeap_BlockHeapJc(BlockHeapJc* ythis)
{
  ythis->nextHeap = theBlockHeapList;
  theBlockHeapList = ythis;
}

//static const int mBeginBlock_BlockHeap = ~(kSizeNormalBlock_BlockHeap-1);


/**Reference to the array of all control structures of BlockHeaps. */
//BlockHeapJcARRAY* all_BlockHeap;




#define kOffsetData_BlockHeapBlockJc 0



#if defined(mBackRef_REF_ObjectJc)
  /** To support debugging, a type of REFP_ObjectJc-array is defined and used inside.
    * The number of elements is a arbitrary number, convenient for debugging.
    * The really number of elements is determined by using.
    */
  typedef REF_ObjectJc* REF_ObjectJc_array[20];
#endif


/*
xxxBlockHeapJcARRAY* new_BlockHeapJcARRAY(int nrofElements)
{ int nrofBytes = SIZEOF_BlockHeapJcARRAY(nrofElements);
  xxxBlockHeapJcARRAY* ptr = (xxxBlockHeapJcARRAY*)(alloc_MemC(nrofBytes).address);
  if(ptr != null)
  { ctor_ObjectArrayJc(&ptr->head, nrofElements, sizeof(BlockHeapJc), null, 0);
  }
  return ptr;
}
*/
/*
void* alloc_sBlockHeapJc(int size)
{ void* ptr;
  STACKTRC_ENTRY("alloc_sBlockHeapJc");
  if(current_BlockHeapJc != null)
  { ptr = alloc_BlockHeapJc(current_BlockHeapJc, size);
  }
  else
  { ptr = mallocFromOpSysJc(size);
  }
  STACKTRC_LEAVE; return(ptr);
}
*/
//BlockHeapJc* theDefaultBlockHeap;

/*
bool initall_BlockHeapJc(int nrofHeaps)
{ int nrofByteAllHeaps = sizeof_BlockHeapJcARRAYd(nrofHeaps);
  STACKTRC_ENTRY("initall_BlockHeap");

  all_BlockHeap = (BlockHeapJcARRAYd*)mallocFromOpSysJc(nrofByteAllHeaps);
  if(all_BlockHeap == null) THROW(RuntimeException, "no memory", false);
  all_BlockHeap->array.length = nrofHeaps;
  all_BlockHeap->array.sizeElement = sizeof(BlockHeapJc);
  //all_BlockHeap->array.mode = kDirect_ObjectArrayJc;
  memset(all_BlockHeap->data, 0, nrofHeaps * sizeof(BlockHeapJc));
  STACKTRC_LEAVE; return true;
}



void init_i_s_BlockHeapJc(int idxHeap, MemUnit* heap, int sizeHeap)
{
  BlockHeapJc* heapCtrl = get_BlockHeapJcARRAYd(all_BlockHeap, idxHeap);
  MemC memHeap = { sizeHeap, (struct MemAreaC_t*)heap};
  MemC memCtrl = { sizeof(BlockHeapJc), (struct MemAreaC_t*)heapCtrl};
  ctor_BlockHeapJc(memCtrl, memHeap, 0x400, 0x40);
}
*/

METHOD_C BlockHeapJc* ctor_BlockHeapJc(MemC rawMem, MemC wholeHeap, int bytesNormalBlock, int bytesSmallBlock)
{
  BlockHeapJc* ythis = PTR_MemC(rawMem, BlockHeapJc);
  int zBlock;
  struct MemAreaC_t* heap = PTR_MemC(wholeHeap, struct MemAreaC_t);
  int sizeHeap = size_MemC(wholeHeap);
  STACKTRC_ENTRY("ctor_BlockHeapJc");
  if(size_MemC(rawMem) < sizeof(BlockHeapJc))
  { THROW_s0(RuntimeException, "ctor mem-size insufficient", size_MemC(rawMem));
  }
  init0_MemC(rawMem);
  init0_MemC(wholeHeap);

  //:TODO: Test signifity of bytesNormalBlock and bytesSmallBlock!

  ythis->bytesNormalBlock = bytesNormalBlock;
  ythis->mAdressNormalBlock_BlockHeap = ~(bytesNormalBlock -1);

  ythis->bytesSmallBlock = bytesSmallBlock;
  ythis->mAdressSmallBlock_BlockHeap = ~(bytesSmallBlock -1);

  if( ((int32)heap & ythis->mAdressNormalBlock_BlockHeap) != 0)
  { //if the heap donot starts at a address with mask boundary, increment the address to the next boundary
    heap = (struct MemAreaC_t*)( ((int32)heap & ythis->mAdressNormalBlock_BlockHeap) + bytesNormalBlock );
    //and reduce the number of blocks, because the end address should be less than the given one.
    sizeHeap -= bytesNormalBlock;
  }

  ythis->zBlock = zBlock = sizeHeap / bytesNormalBlock;
  ythis->heapBegin = (BlockHeapBlockJc_debugArray*)heap;
  ythis->heapEnd   = addOffset_MemAreaC(ythis->heapBegin, zBlock * bytesNormalBlock);


  //ythis->theGarbageCollectorThread = Thread::new_(ythis, "GarbageCollector");
  //ythis->theGarbageCollectorThread->setPriority(Thread::NORM_PRIORITY -1);

  //if(heap==0) throw new RuntimeException("BlockHeap::init(): no mem");

  //Object__BaseRefef::BlockHeapEnd = (MemUnit*)(heap) + zBlock * kSizeNormalBlockHeapBlockJc;

  ythis->firstFreeBlock = (BlockHeapBlockJc*)(heap);

  { //mark all free Blocks with a single linked list
    BlockHeapBlockJc* block = ythis->firstFreeBlock;
    int ii;
    for(ii=1; ii< zBlock; ii++)  //take the next block
    { BlockHeapBlockJc* nextBlock = (BlockHeapBlockJc*)(&((MemUnit*)heap)[ii * bytesNormalBlock]);
      //bbb block->ctrl.typeAndSize = (int16)kFree_Type_BlockHeapBlock;
      block->typeOrMaxRef = (int16)kFree_Type_BlockHeapBlock;
      //bbb *(BlockHeapBlockJc**)(&block->data[0]) = nextBlock;
      block->nextBlock = nextBlock;
      block = nextBlock;
    }
    //handle the last block
    //bbb block->ctrl.typeAndSize = (int16)kFree_Type_BlockHeapBlock;
    block->typeOrMaxRef = (int16)kFree_Type_BlockHeapBlock;
    //bbb block->data[0] = 0;     //the last block has no next.
    block->nextBlock = null;  //the last block has no next.
    ythis->lastFreeBlock = block;  //append a free becoming block here.
  }

  //iLastSmallBlock = 0;
  //iNextNormalBlock = 1;


  ythis->firstMapEntry = null;

  /*
  if(current_BlockHeapJc == null)
  { //the first initialized blockheap is the current.
    current_BlockHeapJc = ythis;
  }
  */

  //insert this heap in the chain of heaps.
  ythis->nextHeap = theBlockHeapList;  //null if it is the first one.
  theBlockHeapList = ythis;
  STACKTRC_LEAVE;
  return ythis;

}






void setRunMode_BlockHeapJc(BlockHeapJc* ythis, struct LogMessageFW_t* log, int kIdentMsgAlloc, int kIdentMsgFree, int kIdentMsgGcWork)
{ ythis->log = log;
  ythis->kIdentMsgAlloc = kIdentMsgAlloc;
  ythis->kIdentMsgFree = kIdentMsgFree;
  ythis->kIdentMsgGcWork = kIdentMsgGcWork;

  ythis->bitInitMode = 0x1234abcd;
}



MemC alloc_s_sBlockHeapJc(int sizeObj, const char* sCallInfo, ThCxt* _thCxt)
{ //STACKTRC_NAME("alloc_s_BlockHeap")
  return alloc_iis_BlockHeapJc(current_sBlockHeapJc(_thCxt), sizeObj, kReferencesStd_BlockHeap, sCallInfo, _thCxt);
}


ObjectJc* allocObject_s_sBlockHeapJc(int sizeObj, int identObj, const char* sCallInfo, ThCxt* _thCxt)
{ //STACKTRC_NAME("alloc_s_BlockHeap")
  return allocObject_iis_BlockHeapJc(current_sBlockHeapJc(_thCxt), sizeObj, identObj, kReferencesStd_BlockHeap, sCallInfo, _thCxt);
}




MemC alloc_s_BlockHeapJc(BlockHeapJc* ythis, int sizeObj, const char* sCallInfo, ThCxt* _thCxt)
{ //STACKTRC_NAME("alloc_BlockHeap")
  return alloc_iis_BlockHeapJc(ythis, sizeObj, kReferencesStd_BlockHeap, sCallInfo, _thCxt);
}




MemC alloc_iis_BlockHeapJc(BlockHeapJc* ythis, int sizeObj, int nrofReferences, const char* sCallInfo, ThCxt* _thCxt)
{ ObjectJc* obj = allocObject_iis_BlockHeapJc(ythis, sizeObj, -1, nrofReferences, sCallInfo, _thCxt); 
  MemC ret = build_MemC(obj, getSizeInfo_ObjectJc(obj));
  return ret;
}

ObjectJc* allocObject_iis_BlockHeapJc(BlockHeapJc* ythis, int sizeObj, int identObj, int nrofReferences, const char* sCallInfo, ThCxt* _thCxt)
{ //MemC ret;
  ObjectJc* retObj;
  STACKTRC_TENTRY("alloc_ii_BlockHeap");
  if(sizeObj == -1)
  { //BBB sizeObj = ythis->bytesNormalBlock - sizeof(BlockHeapBlockCtrlJc) - nrofReferences * sizeof(ObjectJc*);
    sizeObj = ythis->bytesNormalBlock - nrofBytesHead_BlockHeapBlockJc - nrofReferences * sizeof(ObjectJcREF*);
  }
  else if(sizeObj == -2)
  { sizeObj = kSizeSmallBlock_BlockHeap - nrofReferences * sizeof(ObjectJcREF*);
  }
  if(ythis == null || ythis->bitInitMode != 0x1234abcd)
  { void* ptr;
  	if(sizeObj==0)
  	{
      sizeObj = 20;
  		ptr = PTR_MemC(alloc_MemC(20), void);
  	  #if 0
  	  { char sText[100];
  	    sprintf(sText, "\n BlockHeap::alloc(): sizeObj=0, ptr=%p ",ptr);
  	    report(6,sText);
  	    if(ptr) *(int*)(ptr) = 0xabac1213;
  	  }
  	  #endif
  	}
  	else
  	{ ptr = PTR_MemC(alloc_MemC(sizeObj), void);
  	}
    if(ptr==0)
    { //printf("\nBlockHeap::alloc(): no mem in init mode, size:%iL\n",sizeObj); //throw new RuntimeException("BlockHeap::alloc(): no mem in init mode");
      //exit(5);
    }
    memset(ptr, 0, sizeObj);
    retObj = (ObjectJc*)ptr;
    ctorc_ObjectJc(retObj);
    setSizeAndIdent_ObjectJc(retObj, sizeObj, identObj, 0);
    //setSizeAndOffset_MemC(ret, sizeObj, 0);
    //ret.address = (struct MemAreaC_t*)(ptr);
  }
  else
  { //alloc a Block in the BlockHeap-pool:
    BlockHeapBlockJc* block = null;
    int maxRef;
    int minSizeBlock = nrofBytesHead_BlockHeapBlockJc + sizeObj + nrofReferences * sizeof(ObjectJcREF*);  //add the size of the references array to the requested size.
    if(minSizeBlock > (ythis->bytesNormalBlock - kOffsetData_BlockHeapBlockJc))
     THROW_s0(RuntimeException, "BlockHeap::alloc(): size to large", minSizeBlock);
    else if(minSizeBlock >= 0) //Object::kSizeNormalBlockHeapBlockJc / 8)
    { //after the atomare instruction the first Free Block is no longer available
      //for other threads. So no lock are necessary.
      //bbb maxRef = (ythis->bytesNormalBlock - sizeof(BlockHeapBlockCtrlJc) - sizeObj) / sizeof(ObjectJc*);
      maxRef = (ythis->bytesNormalBlock - nrofBytesHead_BlockHeapBlockJc - sizeObj) / sizeof(ObjectJcREF*);
      //disableSwitch_Thread();
      { block = ythis->firstFreeBlock;
        if(block)
        { ythis->firstFreeBlock = block->nextBlock;
          //max. nr of storeable back-references, yet not consideration from garbage Collector, see activateGarbageCollectorAccess_BlockHeapJc(ObjectJc):
          block->typeOrMaxRef = maxRef;
          #ifdef __RUNTIMEHEAP_TEST__
            block->references__debug = null;
          #endif
        }

      }
      //enableSwitch_Thread();
    }
    else
    { //small block
      maxRef = 0x1;
    }
    if(block != null)
    { int offsetObjToBlock = ythis->bytesNormalBlock - sizeObj;
      block->heapidxAndMaxref = maxRef + (ythis->idxHeapCtrl << kBitHeapIdx_ObjectJc_BlockHeap);
      block->nextBlock  = null;  //NOTE: it had contain the pointer to the next block and is now used as backRef
      block->sCreaterInfo = sCallInfo;
      block->timeCreation = os_milliTime();
      block->backRefs = (ObjectJcREFArray*)addOffset_MemAreaC(block,  sizeof(BlockHeapBlockJc));
      //bbb ret.address = (struct MemAreaC_t*)(block->data);  //returns the Adress of data within BlockHeapBlockJc
      //arrange the data at end of the block!
      //NOTE: If a pointer is confused or a wee index error occurs, the start of the next block will be overwritten
      retObj = (ObjectJc*)addOffset_MemAreaC(block, offsetObjToBlock);;
      block->obj = retObj;
      memset(retObj, 0, sizeObj);
      ctorc_ObjectJc(retObj);
      retObj->blockHeapBlock = block;
      setSizeAndIdent_ObjectJc(retObj, sizeObj, identObj, 0);
      //setSizeAndOffset_MemC(ret, sizeObj, -offsetObjToBlock);
      //ret.address = addOffset_MemAreaC(block, offsetObjToBlock);
      sendMsg_tsv_LogMessageFW(ythis->log, ythis->kIdentMsgAlloc, os_getDateTime(), "alloc_BlockHeap; block=%p; + %d; id=%d; caller=%s", block, sizeObj, identObj, sCallInfo); 
    }
    else
    { retObj = null;
      THROW_s0(RuntimeException, "BlockHeap::alloc(): no memblock", 0);
      //setSizeAndOffset_MemC(ret, 0, 0);
      //ret.address = null;
    }
  }
  STACKTRC_LEAVE; return retObj;
}



METHOD_C void free_BlockHeapJc(BlockHeapJc* ythis, BlockHeapBlockJc* block)
{
  //bbb block->ctrl.typeAndSize = kFree_Type_BlockHeapBlock;
  block->typeOrMaxRef = kFree_Type_BlockHeapBlock;
  block->heapidxAndMaxref = 0;
  //bbb block->data[0] = 0;
  block->nextBlock = null;  //reference to the next block, no next block
  //disableSwitch_Thread();
  //bbb *((BlockHeapBlockJc**)(&ythis->lastFreeBlock->data[0])) = block;  //append in list on end
  ythis->lastFreeBlock->nextBlock = block;  //append in list on end
  ythis->lastFreeBlock = block;        //this is the last free block
  //enableSwitch_Thread();
}




METHOD_C void free_sBlockHeapJc(MemC obj)
{
  BlockHeapJc* heap = null;
  BlockHeapBlockJc* block;

  block = deduceBlockHeapBlockFromObject(PTR_MemC(obj, void), &heap);
  if(heap != null)
  { free_BlockHeapJc(heap, block);
  }
  else
  { //not a block from BlockHeap, use free
    //TODO test siezof ... free(objP);
  }
}








void setLogMessageOutput_BlockHeapJc(struct LogMessageFW_t* log)
{


}





/*****************************************************************************
*
*
*/



#include "Jc/ListMapEntryJc.h"  //includes pkgSystem/Object.h, pkgSystem/String.h





typedef struct MapEntryBlockJc_t
{ ObjectJc object;
  //friend class BlockHeap;
  /** a defined Nr of MapEntry_*/

  /** The really number of entries depends on the actual size of a runtimeheap block*/
  ListMapEntryJc entries[ 20//( BlockHeap::kSizeNormalBlockHeapBlockJc    //size of a block altogether
                      //- sizeof(ObjectJc)     //baseclass of this class
                      //) / sizeof(MapEntryJc)
                   ];   //count of chars defined in src.
  //virtual ~MapEntryBlock(){}
}MapEntryBlockJc;




#if 0
ListMapEntryJc* new_ListMapEntryJc(ObjectJc* parentRef, REF_ObjectJc* obj, REF_ObjectJc* key, MapEntryJc* parent)
{ MapEntryJc* entry = null; //searchFreeItem(parentRef);  //set the parent in key_Map and obj_Map
  /**attention: the following castings from void* to Object* may done from a interface class
     so the pointer pointers not to Object, but to the position of the virtual methode list
     inside the object.
     The rightly conversion to the same type by user supplies the right pointer.
     //???This is only significant for the run of the garbage collector,
     the backward references from the Object to this ref pointers
  */
  entry->key_Map = *key;
  entry->obj_Map = *obj;
  entry->left_Map = null;
  entry->right_Map = null;
  entry->parent_Map = parent;
  entry->mark_Map = 0;
  return entry;
}

REF_ObjectJc setObj_MapEntry(ListMapEntryJc* ythis, REF_ObjectJc* obj)
{ REF_ObjectJc old = ythis->obj_Map;
  ythis->obj_Map = *obj;
  return old;
}

#endif



#if 0
/** redirect malloc*/
void * malloc(size_t size)
//void* malloc(size_t size)
{ return mallocFromOpSysJc(size);
}


void free(void* ptr)
{ freeFromOpSysJc(ptr);
}
#endif

#if defined(xx__CPLUSPLUSJcpp) && defined(__cplusplus)
  void* ::new(size_t size)
  { return mallocFromOpSysJc(size);
  }

  void ::delete(void* ptr)
  { freeFromOpSysJc(ptr);
  }
#endif  //__CPLUSPLUSJcpp




