/************************************************************************************************
 * Copyright/Copyleft:
 *
 * For this source the LGPL Lesser General Public License,
 * published by the Free Software Foundation is valid.
 * It means:
 * 1) You can use this source without any restriction for any desired purpose.
 * 2) You can redistribute copies of this source to everybody.
 * 3) Every user of this source, also the user of redistribute copies
 *    with or without payment, must accept this license for further using.
 * 4) But the LPGL ist not appropriate for a whole software product,
 *    if this source is only a part of them. It means, the user
 *    must publish this part of source,
 *    but don't need to publish the whole source of the own product.
 * 5) You can study and modify (improve) this source
 *    for own using or for redistribution, but you have to license the
 *    modified sources likewise under this LGPL Lesser General Public License.
 *    You mustn't delete this Copyright/Copyleft inscription in this source file.
 *
 * This source may be used also with another licence, if the author 
 * and all other here named co-authors have agreed to this contract.
 * Especially a company can use a copy of this sources in its products without publishing.
 * The user should have a underwritten contract therefore.
 *
 * @author Hartmut Schorrig, Germany, Pinzberg, www.vishia.org
 *
 **copyright***************************************************************************************
 *
 * @content Implementation of a ThreadContext for os-level.
 *
 *
 * @author JcHartmut www.vishia.org
 * @version 0.83
 * list of changes:
 * 2007-05-00: JcHartmut creation
 *
 ****************************************************************************/
#include "fw_ThreadContext.h"
#include "fw_SimpleC.h"
//#include "ObjectJc.h"
//#include "fw_Exception.h"
//#include "StringJc.h"
#include "OSAL/inc/os_thread.h"
//#include "os_ThreadContext.h"
#include "fw_MemC.h"
//#undef BOOL
//#undef PBOOL
//#undef boolean

#include <string.h>

//#include <wtypes.h>
//#include <Winbase.h>


/*
OS_ThreadContext* ctorM_OS_ThreadContext(MemC mthis)
{
  OS_ThreadContext* ythis = (OS_ThreadContext*)mthis.address;
  int nrofStacktraceEntries = (mthis.size_ - sizeof(OS_ThreadContext) + sizeof(ythis->stacktraceThreadContext.stacktraceBuffer)) / sizeof(StacktraceElementJc);
  init0_MemC(mthis);
  
  ctorc_OS_ThreadContext(ythis, "unnamed", nrofStacktraceEntries);
  return ythis;
}


OS_ThreadContext* ctorc_OS_ThreadContext(OS_ThreadContext* ythis, const char* name, int maxNrofEntriesStacktraceBuffer)
{
  ythis->sSignificanceText = sSignificanceText_OS_ThreadContext;
  ythis->THandle = 0;  //TODO os_getThreadId();
  ythis->uTID = 0;  //TODO os_getThreadId();
  ythis->EvHandle = 0;  //TODO os_getThreadId();
  ythis->uFlagRegister = 0;  
  memset(&ythis->bufferInThreadContext, 0, sizeof(ythis->bufferInThreadContext));
  ythis->blockHeap = null;
  memset(&ythis->stacktraceThreadContext.stacktrace,0, sizeof(ythis->stacktraceThreadContext.stacktrace));
  memset(&ythis->stacktraceThreadContext.threadContext,0, sizeof(ythis->stacktraceThreadContext.threadContext));
  ythis->stacktraceThreadContext.nrofEntriesStacktraceBuffer = 0;
  ythis->stacktraceThreadContext.maxNrofEntriesStacktraceBuffer = maxNrofEntriesStacktraceBuffer;
  memset(ythis->stacktraceThreadContext.stacktraceBuffer,0, maxNrofEntriesStacktraceBuffer * sizeof(ythis->stacktraceThreadContext.stacktraceBuffer[0]));
  

  ythis->name = name;
  //ythis->stacktraceBuffer = new_StacktraceElementJcARRAY(100);
  ythis->stacktraceThreadContext.nrofEntriesStacktraceBuffer = 0;
  ythis->stacktraceThreadContext.maxNrofEntriesStacktraceBuffer = maxNrofEntriesStacktraceBuffer;
  ythis->stacktraceThreadContext.threadContext = ythis;
  return ythis;
  //NO: because the stacktrac is used. ythis->excMsg = ctorM_StringBufferJc(alloc_MemC(400));
  //ythis->excMsg = null; 
}
*/


void ctorc_ThreadContextFW(ThreadContextFW_s* ythis)
{
  ctorc_StacktraceThreadContext(&ythis->stacktraceThreadContext);
}


/**Sets a new buffer in Threadcontext.
 */
METHOD_C MemC os_setBufferInThreadContext(MemC newBuffer, ThCxt* threadContext)
{ MemC lastBuffer;
  if(threadContext == null)
  { MemC memThreadContext = os_getCurrentUserThreadContext();  //this should not be occuring.
    threadContext = PTR_MemC(memThreadContext, ThreadContextFW_s);
  }
  lastBuffer = threadContext->bufferInThreadContext;
  threadContext->bufferInThreadContext = newBuffer;
  return lastBuffer;  //NOTE: the user is responsible for saving its content.
}

METHOD_C MemC os_getBufferInThreadContext(ThCxt* threadContext)
{ MemC buffer;
  if(threadContext == null)
  { MemC memThreadContext = os_getCurrentUserThreadContext();  //this should not be occuring.
    threadContext = PTR_MemC(memThreadContext, ThreadContextFW_s);
  }
  buffer = threadContext->bufferInThreadContext;
  if(PTR_MemC(buffer, void) == null)
  { buffer = alloc_MemC(2000);
    threadContext->bufferInThreadContext = buffer;  //NOTE: struct-copy to save.
  }
  return buffer;  //NOTE: the user is responsible for saving its content.
}



/**This mehtod is necessary because the user shouldn't know the struct ThreadContext. 
 * It should be hidden, but the embedded part of threadcontext for Stacktrace handling 
 * should be known in all user routines because it is used inline-like.
 */
ThreadContextFW_s* getCurrent_ThreadContextFW()
{ ThreadContextFW_s* thC;
  MemC memThreadContext = os_getCurrentUserThreadContext();  //The users thread context is managed but not knwon in detail from osal.
  thC = PTR_MemC(memThreadContext, ThreadContextFW_s);
  if(thC == null)
  { memThreadContext = alloc_MemC(sizeof(ThreadContextFW_s));
    os_setCurrentUserThreadContext(memThreadContext);  
    thC = PTR_MemC(memThreadContext, ThreadContextFW_s);
    ctorc_ThreadContextFW(thC);
  }
  return thC;  //it is a embedded struct inside the whole ThreadContext.
}


