/**************************************************************************
 * This file is generated by Java2C
 **copyright***************************************************************
 *************************************************************************/
#ifndef __StringPartJc_h__
#define __StringPartJc_h__

#include "Jc/ObjectJc.h"

#include "Fwc/fw_Exception.h"   //basic concept

#include "AllReferencesJcJ2C.h"


/*@CLASS_C StringPartJc @@@@@@@@@@@@@@@@@@@@@@@@*/

typedef struct StringPartJc_t
{ ObjectJc object;
  int32 start; /*j2c:%*/  /*The actual start position of the valid part.*/
  int32 end; /*j2c:%*/  /*The actual exclusive end position of the valid part.*/
  int32 startMin; /*j2c:%*/  /*The leftest possible start position*/
  int32 endMax; /*j2c:%*/  /*The rightest possible exclusive end position*/
  StringJc content; /*j2c:%*/  /*The referenced string*/
  int32 nLineCt; /*j2c:%*/  /*The line number, counted by founded \n */
  bool bCurrentOk; /*j2c:%*/  /*false if current scanning is not match*/
  bool bStartScan; /*j2c:%*/  /*If true, than all idxLastScanned..*/
  int32 startLast; /*j2c:%*/  /*Borders of the last part before calling of scan__(), seek__(), lento__()*/
  int32 endLast; /*j2c:%*/  /*Borders of the last part before calling of scan__(), seek__(), lento__()*/
  int32 startScan; /*j2c:%*/  /*Position of scanStart() or after scanOk() as start of next scan operations. */
  bool bFound; /*j2c:%*/  /*True if the last operation of lento__() is not failed. See isFound();*/
  struct { ObjectJc object; int32 length; int16 sizeElement; int16 mode; int64 data[5]; } nLastIntegerNumber; /*j2c:larray[%]*/  /*Last scanned integer number*/
  int32 idxLastIntegerNumber; /*j2c:%*/  /*Last scanned integer number*/
  double nLastFloatNumber; /*j2c:%*/  /*Last scanned float number*/
  StringJc sLastString; /*j2c:%*/  /*Last scanned string. */
  int32 bitMode; /*j2c:%*/  /*Some mode bits */
  StringJc sCommentStart; /*j2c:%*/  /*The string defined the start of comment inside a text.*/
  StringJc sCommentEnd; /*j2c:%*/  /*The string defined the end of comment inside a text.*/
  StringJc sCommentToEol; /*j2c:%*/  /*The string defined the start of comment to end of line*/
} StringPartJc_s;
  

typedef struct StringPartJc_Y_t { ObjectJc object; int32 length; int16 sizeElement; int16 mode; StringPartJc_s data[50]; } *StringPartJc_Y;

extern struct ClassJc_t const reflection_StringPartJc_s;
  

  #define seekEnd_StringPartJc 1 /*j2c:%d*/  /*Flag to force setting the start position after the seeking string*/
  #define mSeekBackward__StringPartJc 0x10 /*j2c:%d*/  /*Flag bit to force seeking backward*/
  #define mSeekToLeft__StringPartJc 0x40 /*j2c:%d*/  /*Flag bit to force seeking left from start (Backward)*/
  extern const int32 seekToLeft_StringPartJc; /*j2c:%*/  /*Flag to force seeking backward from the start position*/
  extern const int32 seekBack_StringPartJc; /*j2c:%*/  /*Flag to force seeking backward from the end position*/
  #define seekNormal_StringPartJc 0 /*j2c:%d*/  /*Flag to force seeking forward*/
  #define mSkipOverWhitespace_mode_StringPartJc 0x1 /*j2c:%d*/  /*Bit in mode*/
  #define mSkipOverCommentInsideText_mode_StringPartJc 0x2 /*j2c:%d*/  /*Bit in mode*/
  #define mSkipOverCommentToEol_mode_StringPartJc 0x4 /*j2c:%d*/  /*Bit in mode*/
  extern const char cStartOfText_StringPartJc; /*j2c:%*/  /*The char used to code start of text. */
  extern const char cEndOfText_StringPartJc; /*j2c:%*/  /*The char used to code end of text. */

/**Interface to report something, only level Report.fineDebug is used.*/
METHOD_C StringPartJc_s* ctorO_StringPartJc(ObjectJc* yObj, ThCxt* _thCxt);

/**Creates a new StringPart, with the given content from a String*/
METHOD_C StringPartJc_s* ctorO_S_StringPartJc(ObjectJc* yObj, StringJc content /*j2c:%*/, ThCxt* _thCxt);

/**Creates a new StringPart with the same String as the given StringPart*/
METHOD_C StringPartJc_s* ctorO_XX_StringPartJc(ObjectJc* yObj, struct StringPartJc_t* src /*j2c:**/, ThCxt* _thCxt);



void finalize_StringPartJc(ObjectJc* yObj, ThCxt* _thCxt);

/**Sets the content to the given string, forgets the old content*/
METHOD_C StringPartJc_s* assign_S_StringPartJc(StringPartJc_s* ythis, StringJc content /*j2c:%*/, ThCxt* _thCxt);

/**Sets the StringPart with the same String object as the given StringPart, forgets the old content.*/
METHOD_C StringPartJc_s* assign_XX_StringPartJc(StringPartJc_s* ythis, struct StringPartJc_t* src /*j2c:**/, ThCxt* _thCxt);

/**Sets the content of the StringPart , forgets the old content*/
METHOD_C StringPartJc_s* assignFromEnd_StringPartJc(StringPartJc_s* ythis, struct StringPartJc_t* src /*j2c:**/, ThCxt* _thCxt);

/**Set the mode of ignoring comments.*/
METHOD_C bool setIgnoreComment_b_StringPartJc(StringPartJc_s* ythis, bool bSet /*j2c:%*/, ThCxt* _thCxt);

/**Set the character string of inline commentmode of ignoring comments.*/
METHOD_C bool setIgnoreComment_SS_StringPartJc(StringPartJc_s* ythis, StringJc sStart /*j2c:%*/, StringJc sEnd /*j2c:%*/, ThCxt* _thCxt);

/**Set the mode of ignoring comments to end of line.*/
METHOD_C bool setIgnoreEndlineComment_b_StringPartJc(StringPartJc_s* ythis, bool bSet /*j2c:%*/, ThCxt* _thCxt);

/**Set the character string introducing the comments to end of line.*/
METHOD_C bool setIgnoreEndlineComment_S_StringPartJc(StringPartJc_s* ythis, StringJc sStart /*j2c:%*/, ThCxt* _thCxt);

/**Set the mode of ignoring whitespaces.*/
METHOD_C bool setIgnoreWhitespaces_StringPartJc(StringPartJc_s* ythis, bool bSet /*j2c:%*/, ThCxt* _thCxt);

/**Sets the start of the maximal part to the actual start of the valid part.*/
METHOD_C StringPartJc_s* setBeginMaxPart_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Sets the start of the part to the exclusively end, set the end to the end of the content.*/
METHOD_C StringPartJc_s* fromEnd_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**get the Line ct*/
METHOD_C int32 getLineCt_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Gets the length of the valid part*/
METHOD_C int32 getLen_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Returns the valid lenght of the acutual part*/
METHOD_C int32 length_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Returns the lenght of the maximal part from current position*/
METHOD_C int32 lengthMaxPart_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Sets the endposition of the part of string to the given chars after start.*/
METHOD_C StringPartJc_s* lento_i_StringPartJc(StringPartJc_s* ythis, int32 len /*j2c:%*/, ThCxt* _thCxt);

/**Sets the endposition of the part of string to exclusively the char cc.*/
METHOD_C StringPartJc_s* lento_c_StringPartJc(StringPartJc_s* ythis, char cc /*j2c:%*/, ThCxt* _thCxt);

/**Sets the endposition of the part of string to exclusively the given string.*/
METHOD_C StringPartJc_s* lento_S_StringPartJc(StringPartJc_s* ythis, StringJc ss /*j2c:%*/, ThCxt* _thCxt);

/**Sets the endposition of the part of string to exclusively the given string.*/
METHOD_C StringPartJc_s* lento_Si_StringPartJc(StringPartJc_s* ythis, StringJc ss /*j2c:%*/, int32 mode /*j2c:%*/, ThCxt* _thCxt);

/**Sets the endposition of the part of string to the end of the identifier which is beginning on start.*/
METHOD_C StringPartJc_s* lentoIdentifier_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Sets the endposition of the part of string to the end of the identifier which is beginning on start.*/
METHOD_C StringPartJc_s* lentoIdentifier_SS_StringPartJc(StringPartJc_s* ythis, StringJc additionalStartChars /*j2c:%*/, StringJc additionalChars /*j2c:%*/, ThCxt* _thCxt);

/**Sets the len to the first position of any given char, but not if the char is escaped.*/
METHOD_C StringPartJc_s* lentoAnyNonEscapedChar_StringPartJc(StringPartJc_s* ythis, StringJc sCharsEnd /*j2c:%*/, int32 maxToTest /*j2c:%*/, ThCxt* _thCxt);

/**Sets the len to the first position of any given char, but not if the char is escaped.*/
METHOD_C StringPartJc_s* lentoNonEscapedString_StringPartJc(StringPartJc_s* ythis, StringJc sEnd /*j2c:%*/, int32 maxToTest /*j2c:%*/, ThCxt* _thCxt);

/**Displaces the start of the part for some chars to left or to right.*/
METHOD_C StringPartJc_s* seek_i_StringPartJc(StringPartJc_s* ythis, int32 nr /*j2c:%*/, ThCxt* _thCxt);

/**Displaces the start of the part to the first char it is no whitespace.*/
METHOD_C StringPartJc_s* seekNoWhitespace_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**skip over comment and whitespaces*/
METHOD_C StringPartJc_s* skipWhitespaceAndComment_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Displaces the start of the part to the first char it is no whitespace or comment.*/
METHOD_C StringPartJc_s* seekNoWhitespaceOrComments_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/****/
METHOD_C bool isFound_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Returns true, if the last called seek__(), lento__() or skipWhitespaceAndComment()*/
METHOD_C bool found_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Displaces the start of the part to the leftest possible start.*/
METHOD_C StringPartJc_s* seekBegin_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Searchs the given String inside the valid part, posits the start of the part to the begin of the searched string.*/
METHOD_C StringPartJc_s* seek_Si_StringPartJc(StringPartJc_s* ythis, StringJc sSeek /*j2c:%*/, int32 mode /*j2c:%*/, ThCxt* _thCxt);

/**Searchs the given String inside the valid part, posits the start of the part to the begin of the searched string.*/
METHOD_C StringPartJc_s* seekAnyString_StringPartJc(StringPartJc_s* ythis, StringJc_Y strings /*j2c:array_Y[%t]*/, int32_Y nrofFoundString /*j2c:array_Y[%]*/, ThCxt* _thCxt);

/**Searchs the given character inside the valid part, posits the start of the part to the begin of the searched char.*/
METHOD_C StringPartJc_s* seek_ci_StringPartJc(StringPartJc_s* ythis, char cSeek /*j2c:%*/, int32 mode /*j2c:%*/, ThCxt* _thCxt);

/**Searchs the given String inside the valid part, posits the start of the part after the end of the searched string.*/
METHOD_C StringPartJc_s* xxxseekEnd_StringPartJc(StringPartJc_s* ythis, StringJc sSeek /*j2c:%*/, ThCxt* _thCxt);

/**Posits the start of the part after all of the chars given in the parameter string.*/
METHOD_C StringPartJc_s* seekNoChar_StringPartJc(StringPartJc_s* ythis, StringJc sChars /*j2c:%*/, ThCxt* _thCxt);

/**Returns the position of one of the chars in sChars within the part, started inside the part with fromIndex,*/
METHOD_C int32 indexOfAnyChar_Sii_StringPartJc(StringPartJc_s* ythis, StringJc sChars /*j2c:%*/, int32 fromWhere /*j2c:%*/, int32 maxToTest /*j2c:%*/, ThCxt* _thCxt);

/**Returns the last position of one of the chars in sChars*/
METHOD_C int32 lastIndexOfAnyChar_StringPartJc(StringPartJc_s* ythis, StringJc sChars /*j2c:%*/, int32 fromWhere /*j2c:%*/, int32 maxToTest /*j2c:%*/, ThCxt* _thCxt);

/**Returns the position of one of the chars in sChars within the part, started inside the part with fromIndex,*/
METHOD_C int32 indexOfAnyString_StringPartJc(StringPartJc_s* ythis, StringJc_Y listStrings /*j2c:array_Y[%t]*/, int32 fromWhere /*j2c:%*/, int32 maxToTest /*j2c:%*/, int32_Y nrofFoundString /*j2c:array_Y[%]*/, StringJc_Y foundString /*j2c:array_Y[%t]*/, ThCxt* _thCxt);

/**Searches any char contented in sChars,*/
METHOD_C int32 indexOfAnyCharOutsideQuotion_StringPartJc(StringPartJc_s* ythis, StringJc sChars /*j2c:%*/, int32 fromWhere /*j2c:%*/, int32 maxToTest /*j2c:%*/, ThCxt* _thCxt);

/**Searches the end of a quotion string.*/
METHOD_C int32 indexEndOfQuotion_StringPartJc(StringPartJc_s* ythis, char cEndQuotion /*j2c:%*/, int32 fromWhere /*j2c:%*/, int32 maxToTest /*j2c:%*/, ThCxt* _thCxt);

/**Returns the position of one of the chars in sChars within the part,*/
METHOD_C int32 indexOfAnyChar_S_StringPartJc(StringPartJc_s* ythis, StringJc sChars /*j2c:%*/, ThCxt* _thCxt);

/**Returns the position of the first char other than the chars in sChars within the part, started inside the part with fromIndex,*/
METHOD_C int32 indexOfNoChar_Si_StringPartJc(StringPartJc_s* ythis, StringJc sChars /*j2c:%*/, int32 fromWhere /*j2c:%*/, ThCxt* _thCxt);

/**Returns the position of the first char other than the chars in sChars within the part,*/
METHOD_C int32 indexOfNoChar_S_StringPartJc(StringPartJc_s* ythis, StringJc sChars /*j2c:%*/, ThCxt* _thCxt);

/**Sets the length of the current part to any char content in sChars (terminate chars).*/
METHOD_C StringPartJc_s* lentoAnyChar_Si_StringPartJc(StringPartJc_s* ythis, StringJc sChars /*j2c:%*/, int32 maxToTest /*j2c:%*/, ThCxt* _thCxt);

/**Sets the length of the current part to any char content in sChars (terminate chars).*/
METHOD_C StringPartJc_s* lentoAnyChar_Sii_StringPartJc(StringPartJc_s* ythis, StringJc sChars /*j2c:%*/, int32 maxToTest /*j2c:%*/, int32 mode /*j2c:%*/, ThCxt* _thCxt);

/**Sets the length of the current part to any terminate string given in sString.*/
METHOD_C StringPartJc_s* lentoAnyString_SYi_StringPartJc(StringPartJc_s* ythis, StringJc_Y strings /*j2c:array_Y[%t]*/, int32 maxToTest /*j2c:%*/, ThCxt* _thCxt);

/**Sets the length of the current part to any terminate string given in sString.*/
METHOD_C StringPartJc_s* lentoAnyString_SYii_StringPartJc(StringPartJc_s* ythis, StringJc_Y strings /*j2c:array_Y[%t]*/, int32 maxToTest /*j2c:%*/, int32 mode /*j2c:%*/, ThCxt* _thCxt);

/**Sets the length of the current part to any terminate string given in sString.*/
METHOD_C StringJc lentoAnyStringWithIndent_StringPartJc(StringPartJc_s* ythis, StringJc_Y strings /*j2c:array_Y[%t]*/, StringJc sIndentChars /*j2c:%*/, int32 maxToTest /*j2c:%*/, ThCxt* _thCxt);

/**Sets the length of the current part to any char content in sChars (terminate chars),*/
METHOD_C StringPartJc_s* lentoAnyCharOutsideQuotion_StringPartJc(StringPartJc_s* ythis, StringJc sChars /*j2c:%*/, int32 maxToTest /*j2c:%*/, ThCxt* _thCxt);

/**Sets the length of the current part to the end of the quotion*/
METHOD_C StringPartJc_s* lentoQuotionEnd_StringPartJc(StringPartJc_s* ythis, char sEndQuotion /*j2c:%*/, int32 maxToTest /*j2c:%*/, ThCxt* _thCxt);

/**Sets the length of the current part to any char content in sChars (terminate chars).*/
METHOD_C StringPartJc_s* lentoAnyChar_S_StringPartJc(StringPartJc_s* ythis, StringJc sChars /*j2c:%*/, ThCxt* _thCxt);

/**Sets the length to the end of the maximal part if the length is 0*/
METHOD_C StringPartJc_s* len0end_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Sets the length to the end of the maximal part.*/
METHOD_C StringPartJc_s* setLengthMax_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Posits the end of the part before all of the chars given in the parameter string.*/
METHOD_C StringPartJc_s* lenBacktoNoChar_StringPartJc(StringPartJc_s* ythis, StringJc sChars /*j2c:%*/, ThCxt* _thCxt);

/**Trims all leading and trailing whitespaces within the part.*/
METHOD_C StringPartJc_s* trim_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Trims a java- or C-style line-comment from end of part and all leading and trailing whitespaces.*/
METHOD_C StringPartJc_s* trimComment_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Returns the position of the char within the part,*/
METHOD_C int32 indexOf_c_StringPartJc(StringPartJc_s* ythis, char ch /*j2c:%*/, ThCxt* _thCxt);

/**Returns the position of the char within the part, started inside the part with fromIndex,*/
METHOD_C int32 indexOf_ci_StringPartJc(StringPartJc_s* ythis, char ch /*j2c:%*/, int32 fromIndex /*j2c:%*/, ThCxt* _thCxt);

/**Returns the position of the string within the part*/
METHOD_C int32 indexOf_S_StringPartJc(StringPartJc_s* ythis, StringJc sCmp /*j2c:%*/, ThCxt* _thCxt);

/**Returns the position of the string within the part*/
METHOD_C int32 indexOf_Sii_StringPartJc(StringPartJc_s* ythis, StringJc sCmp /*j2c:%*/, int32 fromIndex /*j2c:%*/, int32 maxToTest /*j2c:%*/, ThCxt* _thCxt);

/**Compares the Part of string with the given string*/
METHOD_C bool equals_StringPartJc(StringPartJc_s* ythis, StringJc sCmp /*j2c:%*/, ThCxt* _thCxt);

/**compares the Part of string with the given string.*/
METHOD_C bool startsWith_StringPartJc(StringPartJc_s* ythis, StringJc sCmp /*j2c:%*/, ThCxt* _thCxt);

/**scan next content, test the requested String.*/
METHOD_C StringPartJc_s* scan_StringPartJc(StringPartJc_s* ythis, StringJc sTestP /*j2c:%*/, ThCxt* _thCxt);

/**Test the result of scanning and set the scan Pos Ok, if current scanning was ok*/
METHOD_C bool scanOk_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Test the result of scanning and set the scan Pos Ok, if current scanning was ok*/
METHOD_C StringPartJc_s* scanQuotion_SSSY_StringPartJc(StringPartJc_s* ythis, StringJc sQuotionmarkStart /*j2c:%*/, StringJc sQuotionMarkEnd /*j2c:%*/, StringJc_Y sResult /*j2c:array_Y[%t]*/, ThCxt* _thCxt);

/**Test the result of scanning and set the scan Pos Ok, if current scanning was ok*/
METHOD_C StringPartJc_s* scanQuotion_SSSYi_StringPartJc(StringPartJc_s* ythis, StringJc sQuotionmarkStart /*j2c:%*/, StringJc sQuotionMarkEnd /*j2c:%*/, StringJc_Y sResult /*j2c:array_Y[%t]*/, int32 maxToTest /*j2c:%*/, ThCxt* _thCxt);

/**Scans if it is a integer number, contains exclusively of digits 0..9*/
METHOD_C int64 scanDigits_StringPartJc(StringPartJc_s* ythis, bool bHex /*j2c:%*/, int32 maxNrofChars /*j2c:%*/, ThCxt* _thCxt);

/**Scans if it is a integer number, contains exclusively of digits 0..9*/
METHOD_C void scanStart_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Scans if it is a integer number, contains exclusively of digits 0..9*/
METHOD_C bool scanEntry_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Scans if it is a integer number, contains exclusively of digits 0..9*/
METHOD_C StringPartJc_s* scanPositivInteger_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Scans if it is a integer number, contains exclusively of digits 0..9*/
METHOD_C StringPartJc_s* scanInteger_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Scans if it is a integer number, contains exclusively of digits 0..9*/
METHOD_C StringPartJc_s* scanFloatNumber_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Scans a sequence of hex chars a hex number*/
METHOD_C StringPartJc_s* scanHex_StringPartJc(StringPartJc_s* ythis, int32 maxNrofChars /*j2c:%*/, ThCxt* _thCxt);

/**Scans a integer number possible as hex, or decimal number.*/
METHOD_C StringPartJc_s* scanHexOrDecimal_StringPartJc(StringPartJc_s* ythis, int32 maxNrofChars /*j2c:%*/, ThCxt* _thCxt);

/**Scans a integer number possible as hex, or decimal number.*/
METHOD_C StringPartJc_s* scanIdentifier_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Scans a integer number possible as hex, or decimal number.*/
METHOD_C StringPartJc_s* scanIdentifier_SS_StringPartJc(StringPartJc_s* ythis, StringJc additionalStartChars /*j2c:%*/, StringJc additionalChars /*j2c:%*/, ThCxt* _thCxt);

/**Scans a integer number possible as hex, or decimal number.*/
METHOD_C int64 getLastScannedIntegerNumber_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Scans a integer number possible as hex, or decimal number.*/
METHOD_C double getLastScannedFloatNumber_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Scans a integer number possible as hex, or decimal number.*/
METHOD_C StringJc getLastScannedString_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Gets a String with translitaration.*/
METHOD_C StringJc getCircumScriptionToAnyChar_StringPartJc(StringPartJc_s* ythis, StringJc sCharsEnd /*j2c:%*/, ThCxt* _thCxt);

/**Gets a String with translitaration.*/
METHOD_C StringJc getCircumScriptionToAnyCharOutsideQuotion_StringPartJc(StringPartJc_s* ythis, StringJc sCharsEnd /*j2c:%*/, ThCxt* _thCxt);

/**Gets a String with translitaration.*/
METHOD_C StringJc getCircumScriptionToAnyChar_p_StringPartJc(StringPartJc_s* ythis, StringJc sCharsEnd /*j2c:%*/, bool bOutsideQuotion /*j2c:%*/, ThCxt* _thCxt);

/**Gets the current position, useable for rewind*/
METHOD_C int64 getCurrentPosition_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Sets the current position at a fix position inside the maxPart.*/
METHOD_C void setCurrentPosition_StringPartJc(StringPartJc_s* ythis, int64 pos /*j2c:%*/, ThCxt* _thCxt);

/**Gets a substring inside the maximal part*/
METHOD_C StringJc substring_StringPartJc(StringPartJc_s* ythis, int32 pos /*j2c:%*/, int32 posend /*j2c:%*/, ThCxt* _thCxt);

/**Gets the next chars from current Position.*/
METHOD_C StringJc getCurrent_StringPartJc(StringPartJc_s* ythis, int32 nChars /*j2c:%*/, ThCxt* _thCxt);

/**Gets the next char at current Position.*/
METHOD_C char getCurrentChar_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Gets the current position in line (column of the text).*/
METHOD_C int32 getCurrentColumn_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Returns the actual part of the string.*/
METHOD_C StringJc getCurrentPart_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Returns the last part of the string before any seek or scan operation.*/
METHOD_C StringJc getLastPart_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Returns the actual part of the string.*/
METHOD_C StringJc getCurrentPart_i_StringPartJc(StringPartJc_s* ythis, int32 maxLength /*j2c:%*/, ThCxt* _thCxt);

/**Returns the actual part of the string*/
METHOD_C StringJc toString_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Returns a debug information of the content of the StringPart*/
METHOD_C StringJc debugString_StringPartJc(StringPartJc_s* ythis, ThCxt* _thCxt);

/**Central mehtod to invoke excpetion, usefull to set a breakpoint in debug*/
METHOD_C void throwIndexOutOfBoundsException_StringPartJc(StringPartJc_s* ythis, StringJc sMsg /*j2c:%*/, ThCxt* _thCxt);

#endif //__StringPartJc_h__
