/************************************************************************************************
 * Copyright/Copyleft:
 *
 * For this source the LGPL Lesser General Public License,
 * published by the Free Software Foundation is valid.
 * It means:
 * 1) You can use this source without any restriction for any desired purpose.
 * 2) You can redistribute copies of this source to everybody.
 * 3) Every user of this source, also the user of redistribute copies
 *    with or without payment, must accept this license for further using.
 * 4) But the LPGL ist not appropriate for a whole software product,
 *    if this source is only a part of them. It means, the user
 *    must publish this part of source,
 *    but don't need to publish the whole source of the own product.
 * 5) You can study and modify (improve) this source
 *    for own using or for redistribution, but you have to license the
 *    modified sources likewise under this LGPL Lesser General Public License.
 *    You mustn't delete this Copyright/Copyleft inscription in this source file.
 *
 * This source may be used also with another licence, if the author 
 * and all other here named co-authors have agreed to this contract.
 * Especially a company can use a copy of this sources in its products without publishing.
 * The user should have a underwritten contract therefore.
 *
 * @author Hartmut Schorrig, Germany, Pinzberg, www.vishia.org
 *
 **copyright***************************************************************************************
 *
 * @content
 *
 * @author Hartmut Schorrig, Pinzberg, Germany
 *
 * @version 0.83
 */
#include "Jc/FileIoJc.h"
#include "Jc/ReflectionJc.h"

extern ClassJc const reflection_FileWriterJc_s;


FileWriterJc_s* ctorO_FileWriterJc(ObjectJc* othis, ThCxt* _thCxt)
{
  FileWriterJc_s* ythis = (FileWriterJc_s*)othis;
  STACKTRC_TENTRY("ctorO_FileWriterJc");
  checkConsistence_ObjectJc(othis, sizeof(FileWriterJc_s), &reflection_FileWriterJc_s, _thCxt); 
  
  STACKTRC_LEAVE; return ythis;
}

bool open_FileWriterJc(FileWriterJc_s* ythis, StringJc fileName, ThCxt* _thCxt)
{
  FILE* file;
  char bufferFilename[200];
  STACKTRC_TENTRY("open_FileWriterJc");
  copyToBuffer_StringJc(fileName, bufferFilename, sizeof(bufferFilename));
  { char cc; int ii =0; char* ptr = bufferFilename;
    while(ii < sizeof(bufferFilename) && (cc = *ptr++) != 0)
    { if(cc == '/') 
      { cc = '\\'; 
      }
    }
  }
  file = fopen(bufferFilename, "wb");
  ythis->file = file;

  STACKTRC_LEAVE; return file != null;
}

bool isOpen_FileWriterJc(FileWriterJc_s* ythis)
{ return ythis->file != null;
}

void write_FileWriterJc(FileWriterJc_s* ythis, StringJc text, ThCxt* _thCxt)
{
  FILE* file = (FILE*)ythis->file;
  int nrofChars;
  const char* sText;
  STACKTRC_TENTRY("write_FileWriterJc");
  sText = getCharsAndLength_StringJc(&text, &nrofChars);
  fwrite(sText, nrofChars, 1, file);
  STACKTRC_LEAVE; 
}


void flush_FileWriterJc(FileWriterJc_s* ythis, ThCxt* _thCxt)
{
  FILE* file = (FILE*)ythis->file;
  STACKTRC_TENTRY("flush_FileWriterJc");
  fflush(file);
  STACKTRC_LEAVE; 

}

void close_FileWriterJc(FileWriterJc_s* ythis, ThCxt* _thCxt)
{
  FILE* file = (FILE*)ythis->file;
  STACKTRC_TENTRY("close_FileWriterJc");
  fclose(file);
  STACKTRC_LEAVE; 

}
