/************************************************************************************************
 * Copyright/Copyleft:
 *
 * For this source the LGPL Lesser General Public License,
 * published by the Free Software Foundation is valid.
 * It means:
 * 1) You can use this source without any restriction for any desired purpose.
 * 2) You can redistribute copies of this source to everybody.
 * 3) Every user of this source, also the user of redistribute copies
 *    with or without payment, must accept this license for further using.
 * 4) But the LPGL ist not appropriate for a whole software product,
 *    if this source is only a part of them. It means, the user
 *    must publish this part of source,
 *    but don't need to publish the whole source of the own product.
 * 5) You can study and modify (improve) this source
 *    for own using or for redistribution, but you have to license the
 *    modified sources likewise under this LGPL Lesser General Public License.
 *    You mustn't delete this Copyright/Copyleft inscription in this source file.
 *
 * This source may be used also with another licence, if the author 
 * and all other here named co-authors have agreed to this contract.
 * Especially a company can use a copy of this sources in its products without publishing.
 * The user should have a underwritten contract therefore.
 *
 * @author Hartmut Schorrig, Germany, Pinzberg, www.vishia.org
 *
 **copyright***************************************************************************************
 *
 * @content
 *
 * @author Hartmut Schorrig, Pinzberg, Germany
 *
 * @version 0.83
 */
#ifndef __Jc_FileIoJc_h__
#define __Jc_FileIoJc_h__

#include "Jc/ObjectJc.h"

struct ThreadContextFW_t;

/*@CLASS_C FileWriterJc_s @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/

/**This struct contains the core data of a timestamp. It is contained in DateJc.
 */
typedef struct FileWriterJc_t
{ ObjectJc object;
  void* file;
}FileWriterJc_s;


METHOD_C FileWriterJc_s* ctorO_FileWriterJc(ObjectJc* othis, struct ThreadContextFW_t* _thCxt);

METHOD_C bool open_FileWriterJc(FileWriterJc_s* ythis, StringJc fileName, struct ThreadContextFW_t* _thCxt);

METHOD_C bool isOpen_FileWriterJc(FileWriterJc_s* ythis);

METHOD_C void write_FileWriterJc(FileWriterJc_s* ythis, StringJc text, struct ThreadContextFW_t* _thCxt);

METHOD_C void flush_FileWriterJc(FileWriterJc_s* ythis, struct ThreadContextFW_t* _thCxt);

METHOD_C void close_FileWriterJc(FileWriterJc_s* ythis, struct ThreadContextFW_t* _thCxt);


#endif //__Jc_FileIoJc_h__
