/************************************************************************************************
 * Copyright/Copyleft:
 *
 * For this source the LGPL Lesser General Public License,
 * published by the Free Software Foundation is valid.
 * It means:
 * 1) You can use this source without any restriction for any desired purpose.
 * 2) You can redistribute copies of this source to everybody.
 * 3) Every user of this source, also the user of redistribute copies
 *    with or without payment, must accept this license for further using.
 * 4) But the LPGL ist not appropriate for a whole software product,
 *    if this source is only a part of them. It means, the user
 *    must publish this part of source,
 *    but don't need to publish the whole source of the own product.
 * 5) You can study and modify (improve) this source
 *    for own using or for redistribution, but you have to license the
 *    modified sources likewise under this LGPL Lesser General Public License.
 *    You mustn't delete this Copyright/Copyleft inscription in this source file.
 *
 * This source may be used also with another licence, if the author 
 * and all other here named co-authors have agreed to this contract.
 * Especially a company can use a copy of this sources in its products without publishing.
 * The user should have a underwritten contract therefore.
 *
 * @author Hartmut Schorrig, Germany, Pinzberg, www.vishia.org
 *
 **copyright***************************************************************************************
 *
 * @content
 *
 * @author Hartmut Schorrig, Pinzberg, Germany
 *
 * @version 0.83
 *
 * @content Implementation of Reflection
 *
 * @author Jchartmut www.vishia.org
 * @version 0.82
 * list of changes:
 * 2008-04-22: JcHartmut adap: ReflectionJc.h
 * 2006-05-00: www.vishia.de creation
 *
 ****************************************************************************/
#include "Jc/ReflectionJc.h"
#include "Jc/StringJc.h"
#include "Fwc/fw_Exception.h"
//#include "fw_ThreadContext.h"
/********************************************************************************************/
// Field






/*
FieldJc const* get_FieldJcArray(const FieldJcArray* ythis, int idx)
{ return (FieldJc const*)(get_i_ObjectArrayJc(&ythis->array, idx));
}
*/



const ClassJc* simpleTypes[kREFLECTION_LastConstant] =
{ null    //0x0
, &reflection__voidJc  //0x1
, &reflection__int64Jc          //0x2
, &reflection__uint64Jc         //0x3
, &reflection__int32Jc          //0x4
, &reflection__uint32Jc         //0x5
, &reflection__int16Jc          //0x6
, &reflection__uint16Jc         //0x7
, &reflection__int8Jc           //0x8
, &reflection__uint8Jc          //0x9
, &reflection__intJc            //0xa
, &reflection__uintJc           //0xb
, &reflection__floatJc          //0xc
, &reflection__doubleJc         //0xd
, &reflection__charJc           //0xe
, &reflection__boolJc           //0x0f
, null  //0x10
, null  //0x11
, null  //0x12
, null  //0x13
, null  //0x14
, null  //0x15
, null  //0x16
, null  //0x17
#if defined(__CPLUSPLUSJcpp) && defined(__cplusplus)
, &reflection__ObjectifcBaseJcpp  //0x18
#else
, null
#endif
, &reflection__ObjectJc.clazz  //0x19
, &reflection__ObjectJc.clazz  //0x1a
, &reflection__ObjectArrayJc.clazz  //0x1b
, null  //0x1c   //reserviert evtl Object_ArrayJcpp
, reflection__StringJc  //0x1d
, null  //0x1e
, null  //0x1f
, &reflection__ClassJc.clazz  //0x20
, null  //0x21
, null  //0x22
, null  //0x23
, null  //0x24
, null  //0x25
, null  //0x26
, null  //0x27
, null  //0x28
, null  //0x29
, null  //0x2a
, null  //0x2b
, null  //0x2c
, null  //0x2d
, null  //0x2e
, null  //0x2f
, null  //0x30
, null  //0x31
, null  //0x32
, null  //0x33
, null  //0x34
, null  //0x35
, null  //0x36
, null  //0x37
, null  //0x38
, null  //0x39
, null  //0x3a
, null  //0x3b
, null  //0x3c
, null  //0x3d
, null  //0x3e
, null  //0x3f
, null  //0x40
, &reflection__ObjectJc.clazz             //0x41
, &reflection__ObjectJcpp.clazz        //0x42
, null             //0x43
, null //&reflection__ObjectRefValuesJc"    //0x44
, &reflection__ClassJc.clazz              //0x45
, null  //0x46
, null  //0x47
, null  //0x48
, null  //0x49
, null  //0x4a
, null  //0x4b
, null  //0x4c
, null  //0x4d
, null  //0x4e
, null  //0x4f
};



const char* xxxsSimpleTypeName_ClassJc[kREFLECTION_LastConstant] =
{ ""  //0x0
, "void"  //0x1
, "int64"          //0x2
, "uint64"         //0x3
, "int32"          //0x4
, "uint32"         //0x5
, "int16"          //0x6
, "uint16"         //0x7
, "int8"           //0x8
, "uint8"          //0x9
, "int"            //0xa
, "uint"           //0xb
, "float"          //0xc
, "double"         //0xd
, "char"           //0xe
, "bool"           //0x0f
, ""  //0x10
, ""  //0x11
, ""  //0x12
, ""  //0x13
, ""  //0x14
, ""  //0x15
, ""  //0x16
, ""  //0x17
, "ObjectifcBaseJcpp"  //0x18
, "ObjectJc"  //0x19
, "ObjectJcpp"  //0x1a
, "Object_ArrayJc"  //0x1b
, ""  //0x1c   //reserviert evtl Object_ArrayJcpp
, "StringJc"  //0x1d
, ""  //0x1e
, ""  //0x1f
, "ClassJc"  //0x20
, ""  //0x21
, ""  //0x22
, ""  //0x23
, ""  //0x24
, ""  //0x25
, ""  //0x26
, ""  //0x27
, ""  //0x28
, ""  //0x29
, ""  //0x2a
, ""  //0x2b
, ""  //0x2c
, ""  //0x2d
, ""  //0x2e
, ""  //0x2f
, ""  //0x30
, ""  //0x31
, ""  //0x32
, ""  //0x33
, ""  //0x34
, ""  //0x35
, ""  //0x36
, ""  //0x37
, ""  //0x38
, ""  //0x39
, ""  //0x3a
, ""  //0x3b
, ""  //0x3c
, ""  //0x3d
, ""  //0x3e
, ""  //0x3f
, ""  //0x40
, "ObjectJc"             //0x41
, "ObjectJcpp"        //0x42
, ""             //0x43
, "ObjectRefValuesJc"    //0x44
, "ClassJc"              //0x45
, ""  //0x46
, ""  //0x47
, ""  //0x48
, ""  //0x49
, ""  //0x4a
, ""  //0x4b
, ""  //0x4c
, ""  //0x4d
, ""  //0x4e
, ""  //0x4f
};



ClassJc* ctorM_ClassJc(MemC rawMem)
{ ClassJc* ythis = PTR_MemC(rawMem, ClassJc);
  STACKTRC_ENTRY("ctor_ClassJc");
  if(size_MemC(rawMem)<sizeof(ClassJc)) THROW_s0(IllegalArgumentException, "ctor mem-size insufficient", size_MemC(rawMem));
  ctorc_ClassJc(ythis);
  return ythis;
}



void ctorc_ClassJc(ClassJc* ythis)
{ memset(ythis, 0, sizeof(ClassJc));
  ctorc_ObjectJc(&ythis->object);
  setReflection_ObjectJc(&ythis->object, null, OBJTYPE_ClassJc + sizeof(ClassJc));
}



FieldJc* ctorM_FieldJc(MemC rawMem)
{ FieldJc* ythis = PTR_MemC(rawMem, FieldJc);
  STACKTRC_ENTRY("ctor_FieldJc");
  if(size_MemC(rawMem)<sizeof(FieldJc)) THROW_s0(IllegalArgumentException, "ctor mem-size insufficient", size_MemC(rawMem));
  ctorc_FieldJc(ythis);
  return ythis;
}


void ctorc_FieldJc(FieldJc* ythis)
{
  memset(ythis, 0, sizeof(FieldJc));
  //NOTE: FieldJc hasnot a base ObjectJc.
}


FieldJcArray* new_FieldJcArray(int size)
{ 
  FieldJcArray* ythis = (FieldJcArray*)new_ObjectArrayJc(size, sizeof(FieldJc), null, OBJTYPE_FieldJc);
  /*
  int nrofBytes = sizeof(ObjectArrayJc) + size * sizeof(FieldJc);
  MemC rawMem = alloc_MemC(nrofBytes);
  FieldJcArray* ythis = (FieldJcArray*)ctor_ObjectArrayJc(rawMem);
  setReflection_ObjectJc(&ythis->head.object, null, OBJTYPE_FieldJc + nrofBytes);
  */
  int idx;
  for(idx = 0; idx < size; idx++)
  { ctorc_FieldJc(&ythis->data[idx]);
  }
  return ythis;
}


const char* getName_ClassJc(ClassJc const* ythis)
{ if( ((int)(ythis)) < kREFLECTION_LastConstant )
  { ythis = simpleTypes[(int)(ythis)];
  }
  return ythis->name;
}




METHOD_C bool isPrimitive_ClassJc(ClassJc const* ythis)
{ bool bRet;
  int32 modifiers = getModifiers_ClassJc(ythis);
  bRet = ((modifiers & mPrimitiv_Modifier_reflectJc)!=0);
  return bRet;
}


METHOD_C int32 getModifiers_ClassJc(ClassJc const* ythis)
{
  if( ((int)(ythis)) < kREFLECTION_LastConstant )
  { ythis = simpleTypes[(int)(ythis)];
  }
  return ythis->modifiers;
}


FieldJcArray const* getDeclaredFields_ClassJc(const ClassJc* ythis)
{
  if( ((int)(ythis)) < kREFLECTION_LastConstant )
  { ythis = simpleTypes[(int)(ythis)];
  }
  return ythis->attributes;
}


const FieldJc* getDeclaredField_ClassJc(ClassJc const* ythis, StringJc* sName)
{ int ii;
  bool bFound = false;
  const FieldJc* field = null;
  STACKTRC_ENTRY("getDeclaredField_ClassJc");
  //for(ii=0; !bFound && ii< ythis->attributes->array.length; ii++)
  for(ii=0; !bFound && ii< ythis->attributes->head.length; ii++)
  { //StringJcRef sNameField;
    const char* sNameField;
    //field = get_FieldJcArray(ythis->attributes,ii);
    field = &ythis->attributes->data[ii];
    sNameField = getName_FieldJc(field);
    //if(equals_StringJc(&sNameField,sName_ROOT))
    if(equals_s0_StringJc(*sName, sNameField))
    { bFound= true;
    }
  }
  if(!bFound){ THROW_s(NoSuchFieldException, *sName,0); }
  STACKTRC_LEAVE;
  return field;
}






MethodJc const* getDeclaredMethod_ClassJc(ClassJc const* ythis, char const* sName)
{ int ii;
  bool bFound = false;
  MethodJc const* method;
  STACKTRC_ENTRY("getDeclaredMethod_ClassJc");
  if(ythis->methods == null){ STACKTRC_LEAVE; return(null); }
  for(ii=0; !bFound && ii< ythis->methods->head.length; ii++)
  { StringJc sNameMethod;
    method = get_MethodJcARRAY(ythis->methods,ii);
    sNameMethod = getName_Method(method);
    if(equals_s0_StringJc(sNameMethod, sName))
    { //:TODO: test the param
      bFound= true;
    }
  }
  STACKTRC_LEAVE;
  if(bFound) return method;
  else return null;  //original Java: NoSuchMethodException

}




METHOD_C ClassJc const* getSuperclass_ClassJc(ClassJc const* ythis)
{
  if(ythis->superClasses == null) return null;
  else return ythis->superClasses->data[0].clazz;
}




MethodJcARRAY const* ptrConstCasting_MethodJcARRAY(ObjectArrayJc const* ptr)
{ return (MethodJcARRAY const*)(ptr);
}


#if 0
const StringJcRef* getName_Field(const FieldJc* ythis)
{ return &ythis->name;
}



const MethodJcARRAY* getMethods_ClassJc(const ClassJc* ythis)
{ return ythis->methods;
}

#endif


MethodJc const* get_MethodJcARRAY(const MethodJcARRAY* ythis, int idx)
{ return (MethodJc const*)(get_i_ObjectArrayJc(&ythis->head, idx));
}



const StringJc getName_Method(const MethodJc* ythis)
{ return s0_StringJc(ythis->name);
}






int32 invoke_MethodJcSi(const MethodJc* ythis, void* objP, int32ARRAY* params)
{ ObjectJc* obj = (ObjectJc*)(objP);
  switch(ythis->eType)
  { case kInt_void:
    { //int ret = (obj->*ythis->adress)();
    }break;
    #if 0
    case kInt_Int:
    { int p1 = ((Integer*)(args[0].obj()))->intValue();
      int ret = (obj->*(Object_Method1Int)(adress))(p1);
    } break;
    #endif
  }
  return 0;

}




/**Implementation hint: It is possible, that the type indent is a simple integer number,
   than return the correct representation!
 */
ClassJc const* getType_FieldJc(FieldJc const* ythis)
{ ClassJc const* type = ythis->type;
  if( ((int)(type)) < kREFLECTION_LastConstant )
  { type = simpleTypes[(int)(type)];
  }
  return type;
}







METHOD_C void* getMemoryAddress_FieldJc(const FieldJc* ythis, void const* obj)
{ /* it is assumed, that the obj matches to the Field ythis, it means, the Field ythis
     is getted from a object of exactly this type or from the obj itself.
     This is tested by original Java - set- or get- operations.
     But it is not tested here to optimize calculation time. If it is a part of a
     Java2C-translation, the test should be done on Java-level, if it is a directly
     programmed in C or C++ part, the user should be programmed carefully, how it is
     ordinary in C or C++.
  */
  STACKTRC_ENTRY("getMemoryAddress_FieldJc");
  //:TODO: test obj
  if(ythis->bitModifiers & mSTATIC_Modifier_reflectJc)
  { STACKTRC_LEAVE; return((void*) null); //(ythis->position);
  }
  else
  { void* address = (void*)( ((MemUnit*)(obj)) + ythis->position );
    STACKTRC_LEAVE; return(address);
  }
}



METHOD_C void* getRefAddr_FieldJc(const FieldJc* ythis, void const* obj, int idx)
{ /* it is assumed, that the obj matches to the Field ythis, it means, the Field ythis
     is getted from a object of exactly this type or from the obj itself.
     This is tested by original Java - set- or get- operations.
     But it is not tested here to optimize calculation time. If it is a part of a
     Java2C-translation, the test should be done on Java-level, if it is a directly
     programmed in C or C++ part, the user should be programmed carefully, how it is
     ordinary in C or C++.
  */
  void* retAddress = null;
  STACKTRC_ENTRY("getRefAddr_FieldJc");

  { int32 bitModifiers = ythis->bitModifiers;
    void* adr;  //address of the object at the field
    void* fieldPosAdr = getMemoryAddress_FieldJc(ythis, obj); //memory location of the field inside obj

    if(bitModifiers & mReference_Modifier_reflectJc)
    { //assumed, it is a reference:
      if(bitModifiers & mStaticArray_Modifier_reflectJc)
      { if(idx >=0 && idx < ythis->nrofArrayElements)
        { //interpreting the fieldPosAdr[] not as void, but as array of void*,
          //get the reference of the array position.
          void** fieldPosArrayAddr = (void**)(fieldPosAdr); 
          adr = fieldPosArrayAddr[idx];  //dereferenced at the given position with index.
        }
        //else if(idx == -1){ address = null; }
        else { THROW(IndexOutOfBoundsException, s0_StringJc("index to large"), idx); retAddress = null; }
      }
      else
      { //if a container struct is used, it is referenenced.
        adr = *(void**)(fieldPosAdr);  //dereferenced at the given position.
      }
    }
    else
    { //not a reference, either simple embedded struct, or scalar or container at field position.
      if(bitModifiers & mStaticArray_Modifier_reflectJc)
      { if(idx >=0 && idx < ythis->nrofArrayElements)
        { //TODO this is only valid for pointer!
          ClassJc const* type = getType_FieldJc(ythis);  //the correct type struct, also if simple types.
          int sizeType = type->nSize;
          adr = ((MemUnit*)(fieldPosAdr))+ (idx * sizeType);  //dereferenced at the given position with index.
        }
        //else if(idx == -1){ address = null; }
        else { THROW(IndexOutOfBoundsException, s0_StringJc("index to large"), idx); retAddress = null; }
      }
      else
      { adr = fieldPosAdr;
      }
    }
    if(bitModifiers & mUML_LinkedList_Modifier_reflectJc)
    { retAddress = getRefAddrUML_LinkedList_FieldJc(adr, idx);
    }
    else if(bitModifiers & mUML_ArrayList_Modifier_reflectJc)
    { retAddress = getRefAddrUML_ArrayList_FieldJc(adr, idx);
    }
    else if(bitModifiers & mUML_Map_Modifier_reflectJc)
    { retAddress = getRefAddrUML_Map_FieldJc(adr, idx);
    }
    /*
    else if(bitModifiers & mStaticArray_Modifier_reflectJc)
    { if(idx >=0 && idx < ythis->nrofArrayElements)
      { retAddress = ((void* const*)(adr))[idx];  //dereferenced at the given position with index.
      }
      //else if(idx == -1){ address = null; }
      else { THROW_s0(IndexOutOfBoundsException, "index to large", idx); retAddress = null; }
    }
    */
    else if(bitModifiers & mObjectArrayJc_Modifier_reflectJc && idx >=0)
    { ObjectArrayJc* array = (ObjectArrayJc*)(adr);  //it is known that it is an ObjectArrayJc
      retAddress = get_i_ObjectArrayJc(array, idx);
      if(retAddress == null){ THROW_s0(IndexOutOfBoundsException, "index to large", idx);}
    }
    /*
    else if(bitModifiers & mEmbedded_Modifier_reflectJc)
    { //the struct is embedded, at the actual address
      retAddress = adr;
    }
    else if(bitModifiers & mReference_Modifier_reflectJc)
    { //assumed, it is a reference:
      retAddress = *(void* const*)(adr);  //dereferenced at the given position.
    }
    else
    { //missing modifier, we have no object.
      //retAddress = null;
      //TODO if it is mObjectifcBaseJcpp_Modifier_reflectJc or mObjectJc_Modifier_reflectJc,
      //the mReference_Modifier_reflectJc bit is not set yet. Correct it first in Reflection generation (Xmi2Reflection.xslp).

      retAddress = *(void* const*)(adr);  //dereferenced at the given position.
    }
    */
    else
    { retAddress = adr;
    }
  }
  STACKTRC_LEAVE; return retAddress;
}






METHOD_C int getArraylength_FieldJc(FieldJc const* ythis, void const* obj)
{ /* it is assumed, that the obj matches to the Field ythis, it means, the Field ythis
     is getted from a object of exactly this type or from the obj itself.
     This is tested by original Java - set- or get- operations.
     But it is not tested here to optimize calculation time. If it is a part of a
     Java2C-translation, the test should be done on Java-level, if it is a directly
     programmed in C or C++ part, the user should be programmed carefully, how it is
     ordinary in C or C++.
  */
  int length;
  int32 bitModifiers;
  void* adr;
  STACKTRC_ENTRY("getArraylength_FieldJc");

  bitModifiers = getModifiers_FieldJc(ythis);
  adr = getMemoryAddress_FieldJc(ythis, obj); //memory location of the field inside obj

  if(bitModifiers & mUML_LinkedList_Modifier_reflectJc)
  { length = getArraylengthUML_LinkedList_FieldJc(adr);
  }
  else if(bitModifiers & mUML_ArrayList_Modifier_reflectJc)
  { length = getArraylengthUML_ArrayList_FieldJc(adr);
  }
  else if(bitModifiers & mUML_Map_Modifier_reflectJc)
  { length = getArraylengthUML_Map_FieldJc(adr);
  }
  else if(bitModifiers & mObjectArrayJc_Modifier_reflectJc)
  { ObjectArrayJc* array = (ObjectArrayJc*)(adr);  //it is known that it is an ObjectArrayJc
    length = array->length;
  }
  else if(bitModifiers & mStaticArray_Modifier_reflectJc)
  { void* adr = getMemoryAddress_FieldJc(ythis, obj); //memory location of the field inside obj
    length = getStaticArraySize_FieldJc(ythis);
    while(length > 0 &&  ((void**)(adr))[length-1] == null)  //dereferenced at the given position with index.
    { length -=1;
    }
  }
  else
  { //assumed, it is a reference:
    THROW_s0(NoSuchFieldException, "not an array or container field, field=", (int32)(ythis));
    length = 0;  //dereferenced at the given position.
  }
  STACKTRC_LEAVE;
  return length;
}





//use getClassAndObj_FieldJc, it is the same.
METHOD_C void* get_FieldJc(FieldJc const* ythis, void* obj, int idx)
{ void* ret;
  getClassAndObj_FieldJc(ythis, obj, idx, &ret);
  return ret;
}


METHOD_C void* old_get_FieldJc(FieldJc const* ythis, void* obj, int idx)
{ void* ret;
  #if 0
  if(declaringClass->isObjectIfcBaseJcpp_ClassJc(ythis))
  { //obj may be a pointer of C++-baseclass or interface type,
    //get the adress of ObjectJc base class!
    ObjectIfcBaseJcpp* base = ((ObjectIfcBaseJcpp*)(obj));
    //:TODO: how can it test, if base is correct???
    ret = base->toObjectJc();
  }
  #endif


  //void* adr = getMemoryAddress_FieldJc(ythis, obj); //memory location of the field inside obj
  int32 typeModifier = ythis->bitModifiers;
  int offsetBase = ythis->offsetToObjectifcBase;
  STACKTRC_ENTRY("get_FieldJc");
  if( obj == null)
  { ret = null;
  }
  else if(typeModifier & mObjectJc_Modifier_reflectJc)
  {
    void* ref = getRefAddr_FieldJc(ythis, obj, idx);  //considered a container.
    if(ref == null){ ret = null; }
    else { ret = (ObjectJc*)((MemUnit*)(ref) + offsetBase); }
  }
  #if defined(__CPLUSPLUSJcpp) && defined(__cplusplus)
    else if(typeModifier & mObjectifcBaseJcpp_Modifier_reflectJc)
    { //int offsetToObjectifcBaseJcppMtbl = (typeModifier & mDistanceObjectifcBase_Modifier_reflectJc) >> kBitDistanceObjectifcBase_Modifier_reflectJc;
      void* ref = getRefAddr_FieldJc(ythis, obj, idx);
      if(ref == null){ ret = null; }
      else
      { ObjectifcBaseJcpp* objifc = (ObjectifcBaseJcpp*)((MemUnit*)(ref) + offsetBase);
        ret = objifc->toObject();
      }
    }
  #endif
  else if(typeModifier & mReference_Modifier_reflectJc)
  { ret = getRefAddr_FieldJc(ythis, obj, idx);  //considered a container.;
  }
  else
  {
    //:TODO: primitive type should be wrapped (java) or not or throws exception
    ret = null;
  }
  STACKTRC_LEAVE; return(ret);
}



/**it is a adequat method to get_FieldJc (java: Field.get(obj),
 * but the class is supplied also, because the class may be getted only from ythis, or from the Object.
 * In Java it is more simple: The class is getted anytime from the object.
 */
METHOD_C ClassJc const* getClassAndObj_FieldJc(FieldJc const* ythis, void* obj, int idx, void** retObj)
{ ClassJc const* clazz;
  //void* dstObj;
  int32 modifiers = getModifiers_FieldJc(ythis);
  ObjectJc* retObjBase;

  int32 typeModifier, fieldModifier;
  int offsetBase;
  STACKTRC_ENTRY("getClassAndObj_FieldJc");

  clazz = getType_FieldJc(ythis);  //get class from the field, but it may  be a superclass-reference to a derivated type.
  typeModifier = getModifiers_ClassJc(clazz);
  fieldModifier = ythis->bitModifiers;
  offsetBase = clazz->posObjectBase;
  if( obj == null)
  { *retObj = null;
    //clazz is set from FieldJc-type
  }
  else
  { //ref is the direct address of the referenced object, consider, it may be a embedded, array, container
    void* ref = getRefAddr_FieldJc(ythis, obj, idx);
    if(ref==null)
    { *retObj = null;
      //NOTE: clazz is set from type info in ythis.
    }
    else
    {
      #if defined(__CPLUSPLUSJcpp) && defined(__cplusplus)
        if(typeModifier & mObjectifcBaseJcpp_Modifier_reflectJc)
        { //int offsetToObjectifcBaseJcppMtbl = (typeModifier & mDistanceObjectifcBase_Modifier_reflectJc) >> kBitDistanceObjectifcBase_Modifier_reflectJc;
          ObjectifcBaseJcpp* objifc = (ObjectifcBaseJcpp*)((MemUnit*)(ref) + offsetBase);
          //Significant test:
          if(  objifc->significance_ObjectifcBase == kSignificance_ObjectifcBase
            && objifc->significanceAddress_ObjectifcBase == objifc
            )
          { *retObj = retObjBase = objifc->toObject();
            if(retObjBase != null)
            { clazz = retObjBase->reflectionClass; }   //get Clazz from object itself. It may be null if there is no reflection.
            else{ clazz = null; } //the method toObject() supplies 'return null; '
          }
          else
          { THROW_s0(RuntimeException, "no significance ObjectifcBaseJcpp at address", (int32)objifc);
          } 
        }
        else
      #endif
      if(typeModifier & mObjectJc_Modifier_reflectJc)
      {
        *retObj = retObjBase = (ObjectJc*)((MemUnit*)(ref) + offsetBase);
        clazz = retObjBase->reflectionClass;    //get Clazz from object itself. It may be null if there is no reflection.
      }
      else
      { //a non object based refernce
        *retObj = ref;
        //clazz is set from FieldJc-type
      }
    }
  }
  STACKTRC_LEAVE; return(clazz);
}








/*
  modifiers = getModifiers_ClassJc(clazz);


  if(modifiers & mObjectifcBaseJcpp_Modifier_reflectJc)
  { //it is a type which is derivated from ObjectifcBaseJcpp, than get the ObjectJc-Pointer calling:
    int offsetBase = ythis->offsetToObjectifcBase;
    ObjectifcBaseJcpp* objifc = (ObjectifcBaseJcpp*)((MemUnit*)(ref) + offsetBase);
    objBase = objifc->toObjectJc();
    clazz = objBase->reflectionClass;  //the Class of the object.
  }
  else if(modifiers & mObjectJc_Modifier_reflectJc)
  { //it is a type which is derivated from ObjectifcBaseJcpp, than get the ObjectJc-Pointer calling:
    int offsetBase = ythis->offsetToObjectifcBase;
    objBase = (ObjectJc*)((MemUnit*)(ref) + offsetBase);
    clazz = objBase->reflectionClass;  //the Class of the object.
  }
  else
  {
    *

  if(modifiers & (mObjectJc_Modifier_reflectJc | mObjectifcBaseJcpp_Modifier_reflectJc))
  { //it is known that dstObj is pointer to ObjectJc directly, this is a feature of get_FieldJc.
    //But the dstObj instance itself may be a derivated class, get the class from the getted instance (like java):
    dstObj = get_FieldJc(ythis, obj, idx);  //this call may be thrown!
    if(dstObj != null)
    { clazz = getClass_ObjectJc((ObjectJc*)(dstObj));  //get the clazz from the instance.
    }
    else
    { clazz = null;
    }
  }
  else
  { //nextObj don't based on ObjectJc, but the clazz is supplied from field
    clazz = getType_FieldJc(ythis);  //get from the real object because the reference may be from a base type.
    if(retObj != null)
    { //get the retObj only if it is necessary
      dstObj = getRefAddr_FieldJc(ythis, obj, idx);  //considered a container.
    }
  }
  if(retObj != null){ *retObj = dstObj; }
  STACKTRC_LEAVE; return(clazz);
}
*/


METHOD_C void* searchObject_ClassJc(StringJc sPath, ObjectJc* startObj, FieldJc const** retField, int* retIdx)
{
  void* retObj = null; //default if nothing is found
  //bool bFound = true;
  /*NOTE: usage of set_StringJc() and clear_StringJc() is a exactly mirror of String usage with possible garbage collection,
    here it is not necessary because the Strings are only in Stack focus, but is has not disadvantages.
    The other variant is a simple sName = value. It copies the content..
  */
  StringJc sName = NULL_StringJc;
  StringJc sElement = NULL_StringJc;
  ClassJc const* clazz = getClass_ObjectJc(startObj);
  void* nextObj = startObj;  //the source Object for the next access
  FieldJc const* field = null;
  int idx = -1;
  int posSep;
  int posStart = 0;
  STACKTRC_ENTRY("searchObject_ClassJc");
  TRY
  {
    do
    { int posEnd;
      posSep = indexOf_i_StringJc(sPath, '.', posStart);  //may be <0 if no '.' is found
      posEnd = posSep >= 0 ? posSep : length_StringJc(sPath );
      if(posEnd > posStart)  //should be always, only not on '.' on end.
      { //next loop to search:
        int posBracket;
        retObj = nextObj;
        idx = -1;
        set_StringJc(&sElement, substring_StringJc(sPath, posStart, posEnd, _thCxt));
        posBracket = indexOf_StringJc(sElement, '[');
        { int posAngleBracket = indexOf_StringJc(sElement, '<');
          if(posAngleBracket >=0)
          { posBracket = posAngleBracket;  //may be also <0
          }
          if(posBracket >=0)
          { int posBracketEnd = indexOf_i_StringJc(sElement, posAngleBracket >=0 ? '>' : ']', posBracket + 1 );
            if(posBracketEnd <0) { posBracketEnd = length_StringJc(sElement ); } //if the ] is missing in the actual context
            //get index:
            idx = parseInt_IntegerJc(substring_StringJc(sElement, posBracket +1, posBracketEnd, _thCxt));
            set_StringJc(&sName, substring_StringJc(sElement, 0, posBracket, _thCxt));
          }
          else
          { set_StringJc(&sName, sElement);
          }
        }
        clear_StringJc(&sElement);
        field = getDeclaredField_ClassJc(clazz, &sName);
        clear_StringJc(&sName);

        /*
        //There was some confusion: In last version posBracket >= 0 was testet as positiv entry in if statements.
        //but the idx was > nrofArrayElements and an exception is thrown.
        //The simple test of chars after . may be correct, I think. HSchorrig 2008-01-25

        if(  (  posBracket >= 0     //an index [123] is given, access to the indexed element.
             && (!(bitModifiers & mStaticArray_Modifier_reflectJc)  //not a static array
                || (idx >=0  && idx < ythis->nrofArrayElements) //static array, index in range
             )  )
          || (  posSep >0        //a separator is given, access to the element because it is the base of next loop.
             && (posSep+1) < length_StringJc(&sPath)  //but at least 1 char after separator!
          )  )
        */
        if(  (  posSep >0                             //a separator is given,
             && length_StringJc(sPath ) > (posSep+1) //but at least 1 char after separator!
          )  )
        { //a next loop may be necessary because a . is found:
          //access to the element because it is the base of next loop.
          clazz =  getClassAndObj_FieldJc(field, retObj, idx, &nextObj);
          //nextObj may be null, than exit the loop.
        }
        else; //the obj and field are found.
        posStart = posSep + 1;
      }
    } while(posSep > 0 && nextObj != null);
  } _TRY
  CATCH(NoSuchFieldException, exc)
  { //bFound = false;
    retObj = null; field = null; idx = -1;
  }
  CATCH(Exception, exc)
  { //bFound = false;
    retObj = null; field = null; idx = -1;
  }
  END_TRY

  if(retField != null){ retField[0] = field; }
  if(retIdx != null){ retIdx[0] = idx; }
  STACKTRC_LEAVE; return(retObj);
    //#]
}




METHOD_C void* getReference_FieldJc(FieldJc const* ythis, ObjectJc* obj)
{ void* ret = null;
  int modifiers = getModifiers_FieldJc(ythis);
  STACKTRC_ENTRY("setReference_FieldJc");

  if(isReference_ModifierJc(modifiers))
  { //void* adr = (void**)getMemoryAddress_FieldJc(ythis, obj);
    ret = getRefAddr_FieldJc(ythis, obj, 0);
  }
  else
  { THROW_s0(RuntimeException, "no reference type", 0);
  }
  STACKTRC_LEAVE; return ret;
}



METHOD_C void setReference_FieldJc(FieldJc const* ythis, ObjectJc* obj, void* value)
{ int modifiers = getModifiers_FieldJc(ythis);
  STACKTRC_ENTRY("setReference_FieldJc");

  if(isReference_ModifierJc(modifiers))
  { void** adr = (void**)getMemoryAddress_FieldJc(ythis, obj);
    *adr = value;
  }
  else
  { THROW_s0(RuntimeException, "no reference type", 0);
  }
  STACKTRC_LEAVE;

}



METHOD_C int getInt_FieldJc(const FieldJc* ythis, void* obj)
{ void* adr = getMemoryAddress_FieldJc(ythis, obj);

  //TODO test if it is an integer field!
  return (*(int*)(adr));
}


METHOD_C float getFloat_FieldJc(const FieldJc* ythis, void* obj)
{
  void* adr = getMemoryAddress_FieldJc(ythis, obj);

  //TODO test if it is an integer field!
  return (*(float*)(adr));
}

METHOD_C double getDouble_FieldJc(const FieldJc* ythis, void* obj)
{ //STACKTRC_ENTRY("getDouble_FieldJc")

  void* adr = getMemoryAddress_FieldJc(ythis, obj);

  //TODO test if it is an double field!
  return (*(double*)(adr));
}

METHOD_C bool getBool_FieldJc(const FieldJc* ythis, void* obj)
{ //STACKTRC_ENTRY("getBool_FieldJc")

  void* adr = getMemoryAddress_FieldJc(ythis, obj);

  //TODO test if it is an integer field!
  return (*(bool*)(adr));
}

METHOD_C int64 getInt64_FieldJc(const FieldJc* ythis, void* obj)
{ //STACKTRC_ENTRY("getInt64_FieldJc")

  void* adr = getMemoryAddress_FieldJc(ythis, obj);

  //TODO test if it is an integer field!
  return (*(int64*)(adr));
}

METHOD_C void setInt_FieldJc(const FieldJc* ythis, void* obj, int val)
{ //STACKTRC_ENTRY("setInt_FieldJc")

  void* adr = getMemoryAddress_FieldJc(ythis, obj);

  //TODO test if it is an integer field!
  *(int*)(adr) = val;

}




/************************************************************************/
const ClassJc  reflection__intJc =
{ CONST_ObjectJc(0, &reflection__intJc, null)
  , "int"
  , 0 //Position of the data of this class itself, after some superclasses.
  , sizeof(int32)
  , null  //Attributes
  , null  //Methods
  , null  //superclass
  , null  //interfaces
  , mPrimitiv_Modifier_reflectJc
};



const ClassJc reflection__booleanJc =
{ CONST_ObjectJc(0, &reflection__booleanJc, null)

, "boolean"
, 0 //Position of the data of this class itself, after some superclasses.
, sizeof(int32)
, null  //Attributes
, null  //Methods
, null  //superclass
, null  //interfaces
, mPrimitiv_Modifier_reflectJc
};


const ClassJc reflection__voidJc =
{ CONST_ObjectJc(0, &reflection__voidJc, null)

, "void"
, 0 //Position of the data of this class itself, after some superclasses.
, 0 //no size info available
, null  //Attributes
, null  //Methods
, null  //superclass
, null  //interfaces
, 0
};


const ClassJc reflection__floatJc =
{ CONST_ObjectJc(0, &reflection__floatJc, null)

  , "float"
  , 0 //Position of the data of this class itself, after some superclasses.
  , sizeof(int32)
  , null  //Attributes
  , null  //Methods
  , null  //superclass
  , null  //interfaces
  , mPrimitiv_Modifier_reflectJc
};


const ClassJc reflection__longJc =
{ CONST_ObjectJc(0, &reflection__longJc, null)

, "long"
, 0 //Position of the data of this class itself, after some superclasses.
, sizeof(int32)
, null  //Attributes
, null  //Methods
, null  //superclass
, null  //interfaces
, mPrimitiv_Modifier_reflectJc
};


const ClassJc reflection__byteJc =
{ CONST_ObjectJc(0, &reflection__byteJc, null)

, "byte"
, 0 //Position of the data of this class itself, after some superclasses.
, sizeof(int32)
, null  //Attributes
, null  //Methods
, null  //superclass
, null  //interfaces
, mPrimitiv_Modifier_reflectJc
};


const ClassJc reflection__shortJc =
{ CONST_ObjectJc(0, &reflection__shortJc
, null)
, "short"
, 0 //Position of the data of this class itself, after some superclasses.
, sizeof(int32)
, null  //Attributes
, null  //Methods
, null  //superclass
, null  //interfaces
, mPrimitiv_Modifier_reflectJc
};


const ClassJc reflection__charJc =
{ CONST_ObjectJc(0, &reflection__charJc
, null)
, "char"
, 0 //Position of the data of this class itself, after some superclasses.
, sizeof(char)
, null  //Attributes
, null  //Methods
, null  //superclass
, null  //interfaces
, mPrimitiv_Modifier_reflectJc
};


const ClassJc reflection__doubleJc =
{ CONST_ObjectJc(0, &reflection__doubleJc
, null)
, "double"
, 0 //Position of the data of this class itself, after some superclasses.
, sizeof(double)
, null  //Attributes
, null  //Methods
, null  //superclass
, null  //interfaces
, mPrimitiv_Modifier_reflectJc
};


#if defined(__CPLUSPLUSJcpp) && defined(__cplusplus)

const ClassJc reflection__ObjectifcBaseJcpp =
{ CONST_ObjectJc(0, &reflection__ObjectifcBaseJcpp, null)
, "ObjectifcBaseJcpp"
, 0 //Position of the data of this class itself, after some superclasses.
, sizeof(ObjectifcBaseJcpp)
, null  //Attributes
, null  //Methods
, null  //superclass
, null  //interfaces
, mINTERFACE_Modifier_reflectJc
};
#endif

const Reflection__ObjectJc reflection__ObjectJc
=
{
  { CONST_ObjectJc(0  , &reflection__ObjectJc.clazz, null)
  , "ObjectJc"
  , 0 //Position of the data of this class itself, after some superclasses.
  , sizeof(int32)
  , null  //Attributes
  , null  //Methods
  , null  //superclass
  , null  //interfaces
  , 0 //modifiers
  }
, { (MT_void_Method_void)clone_Object_F
  , (MT_void_Method_void)equals_Object_F
  , (MT_void_Method_void)finalize_Object_F
  , (MT_void_Method_void)hashCode_Object_F
  , (MT_void_Method_void)toString_Object_F
  }
};




const ClassJc xxxreflection_ObjectJc =
{ CONST_ObjectJc(OBJTYPE_ClassJc + sizeof(ClassJc), &xxxreflection_ObjectJc, null)
, "ObjectJc"
, 0
, sizeof(ObjectJc)
, null  //attributes
, null  //method
, null  //superclass
, null  //interfaces
, mObjectJc_Modifier_reflectJc  //modifiers
};





#if 0
const struct ReflectionFieldJc_t reflectionFieldJc
=
{ CONST_dataonly_ClassJc("[LFieldJc", FieldJc)
, { clone_Object_F
  , equals_Object_F
  , finalize_Object_F
  , hashCode_Object_F
  , toString_Object_F
  }
, { CONST_ARRAYJc(FieldJc, 2) //CONST_ObjectJc(0,0), 2, sizeof(FieldJc), 0
  , { CONST_FieldJc(FieldJc, "bitModifiers", bitModifiers, int, 0)
    , CONST_FieldJc(FieldJc, "position", position, int, 0)
    }
  }

};
#endif
