/************************************************************************************************
 * Copyright/Copyleft:
 *
 * For this source the LGPL Lesser General Public License,
 * published by the Free Software Foundation is valid.
 * It means:
 * 1) You can use this source without any restriction for any desired purpose.
 * 2) You can redistribute copies of this source to everybody.
 * 3) Every user of this source, also the user of redistribute copies
 *    with or without payment, must accept this license for further using.
 * 4) But the LPGL ist not appropriate for a whole software product,
 *    if this source is only a part of them. It means, the user
 *    must publish this part of source,
 *    but don't need to publish the whole source of the own product.
 * 5) You can study and modify (improve) this source
 *    for own using or for redistribution, but you have to license the
 *    modified sources likewise under this LGPL Lesser General Public License.
 *    You mustn't delete this Copyright/Copyleft inscription in this source file.
 *
 * This source may be used also with another licence, if the author 
 * and all other here named co-authors have agreed to this contract.
 * Especially a company can use a copy of this sources in its products without publishing.
 * The user should have a underwritten contract therefore.
 *
 * @author Hartmut Schorrig, Germany, Pinzberg, www.vishia.org
 *
 **copyright***************************************************************************************
 *
 * WORKFILE:	MsgDispatcherCpp_MSG.cpp
 *-----------------------------------------------------------------------------
 * TASK:		adaption of the C++-interface to the core C-Routines.
 *-----------------------------------------------------------------------------
 * AUTHOR:		$ Author: Hartmut Schorrig $
 * CREATED:		$Date: 2008/07/31 12:40:26CET$
 * VERSION:   $Revision: 1.1$
 *-----------------------------------------------------------------------------
 * CONTENTS:	
 *-----------------------------------------------------------------------------
 * NOTES:		-
******************************************************************************/

//#include "internal_MsgDispatcher_MSG.h"
//include the own header at first to test its correct dependencies.

//#include "internal_MsgDispatcher_MSG.h"

#if 0
  #include "../gensrc/MsgDispatcher_MSG.c"

  #include "fw_LogMessage.c"
  #include "VaArgBuffer.c"
  #include "MsgOutputFile_MSG.c"
  #include "MsgOutputConsole_MSG.c"
#endif

#include "MsgDispatcherCpp_MSG.h"
#include "MsgDispatcher_MSG.h"
#include "LogMessageFile_MSG.h"
#include "OSAL/inc/os_thread.h"
#include "Jc/ReflectionJc.h"


/* Adaption LogLogMessageFW_i */
extern ClassJc const reflection_LogLogMessageFW_i;


/*
void sendMsg_iDateSiY_LogMessageFW(struct LogMessageFW_t* ythis, int identNumber
, OS_TimeStruct timestamp
, StringJc const text
, struct int32_Y_t* args
, struct SthC_t* _thCxt)
{
  //this method checks the correctness of the instance data
  //and throws an exception if there is a memory overwritten error or initialization error:
  //The casting is deterministic because the type MyStruct is tested.
  Mtbl_LogMessageFW* mtbl = (struct Mtbl_LogMessageFW_t*)getMtbl_ObjectJc(&ythis->object, &reflection_LogLogMessageFW_i);
  const char* text1 = text.ref;
  mtbl->sendMsg_iDateSiY(ythis,identNumber, timestamp, text1, args, _thCxt);


}


ClassJc const reflection_LogLogMessageFW_i =
{ CONST_ObjectJc(OBJTYPE_ClassJc + sizeof(ClassJc), &reflection_LogLogMessageFW_i, null)
, "LogLogMessageFW_i"
, 0     //posObjectJc
, sizeof(LogMessageFW_i)
, null  //attributes and associations
, null  //method
, null  //superclass
, null  //interfaces
, 0x0000000  //modifiers
, null //&mtbl_MsgOutputFile.ObjectJc
};

*/




/* *********************************************************************************/





class MsgDispatcher_MSG * MsgDispatcher_MSG::instance = null;  //initialize it on startup with given parameter.

MsgDispatcher_MSG::MsgDispatcher_MSG(struct MsgDispatcher_MSG_t* data)
: instanceData(data) //, instanceifcData(&data->ifc.LogMessageFW_i) 
{}




#if defined(__CPLUSGEN) && defined(__cplusplus)

int MsgDispatcher_MSG::writeProt(int ident, const char* text, ...)
{ //reference to the varibale arguments in stack:
  va_list args;
  STACKTRC_ENTRY("MsgDispatcher_MSG::writeProt");
  va_start(args, text);
  sendMsgVaList_MsgDispatcher_MSG(&instanceData->super, ident, os_getDateTime(), s0_StringJc(text), args, _thCxt);
  STACKTRC_LEAVE; 
  return 0;
}
/*
  int MsgDispatcher_MSG::writeProt(int ident, const char* text, ...)
  { //reference to the varibale arguments in stack:
    //struct Values_Entry_MsgDispatcher_MSG_t* args = (struct Values_Entry_MsgDispatcher_MSG_t*)((MemUnit*)(&text) + sizeof(text)); 
    //move variable arguments in a fix struct:
    MsgDispatcher_MSG__Entry__Values_s args;
    //ctor_MsgDispatcher_MSG__Entry__Values_s(&args);
    args.v.length = ARRAYLEN(args.v.data);
    int32* argptr = (int32*)((MemUnit*)(&text) + sizeof(text));
    for(int idx = 0; idx < args.v.length; idx++)
    { args.v.data[idx] = argptr[idx];
    }
    sendMsg_iSiY_MsgDispatcher_MSG(instanceData, ident, s0_StringJc(text), CAST_int32_Y(&args.v), os_getCurrentStacktraceThreadContext());
    return 0;
    //return writeProt_tv_MsgDispatcher_MSG( instanceifcData, ident, text, os_getDateTime(), args);
  }
*/





  MsgDispatcher_MSG* MsgDispatcher_MSG::createSingleton(int maxDispatchEntries, int maxQueue)
  { if(instance == null) 
    { instance = new MsgDispatcher_MSG(createSingleton_MsgDispatcher_MSG(maxDispatchEntries, maxQueue)); 
    }
    return instance;
  }
#endif //__cplusplus


MsgDispatcher_MSG_s* createSingleton_MsgDispatcher_MSG(int maxDispatchEntries, int maxQueue)
{ MsgDispatcher_MSG_s* ythis;
  STACKTRC_ENTRY("createSingelton_MsgDispatcher");
  ObjectJc* othis = alloc_ObjectJc(sizeof(MsgDispatcher_MSG_s), 0, _thCxt);
  ythis = ctorO_MsgDispatcher_MSG(othis, maxDispatchEntries, maxQueue, _thCxt);
  
  LogMessageFW_i* consoleOutputQueued = create_LogMessageConsole(_thCxt);
  setOutputRoutine_MsgDispatcher_MSG(ythis, 2, true, consoleOutputQueued, _thCxt);
  
  LogMessageFW_i* consoleOutput = create_LogMessageConsole(_thCxt);
  setOutputRoutine_MsgDispatcher_MSG(ythis, 0, false, consoleOutput, _thCxt);
  

  STACKTRC_LEAVE;
  return ythis;
}




LogMessageFW_i* createLogMessageFile(char const* sFilename, int32 nrofSecondsToFlush, int32 nrofHoursPerFile)
{ STACKTRC_ENTRY("createLogMessageFile");
  ObjectJc* othis = alloc_ObjectJc(sizeof(LogMessageFile_MSG_s), 0, _thCxt);
  LogMessageFile_MSG_s* ythis = ctorO_LogMessageFile_MSG(othis, s0_StringJc(sFilename), nrofSecondsToFlush, nrofHoursPerFile, _thCxt);
  STACKTRC_LEAVE; return &ythis->super;
}



/**This method is the thread run routine.
 * It works in a less prio thread, receipts the message and dispatch it.
 */
int run_MsgDispatcher_MSG(void* zthis)
{ MsgDispatcher_MSG_s* ythis = (MsgDispatcher_MSG_s*)(zthis); //(MsgDispatcher_MSG_s*)zthis;
  STACKTRC_ENTRY("run_MsgDispatcher_MSG");
  ASSERT(instanceof_ObjectJc(&ythis->super.object, &reflection_MsgDispatcher_MSG_s));
  if(false) //ythis->mtbl != &mtbl_MsgDispatcher_MSG)
  { printf("fault ThreadData");
    *((int*)null) = 0;  //stop execution 
    STACKTRC_LEAVE;
  }
  else
  { 
    while(true)
    { int nrofMessages = dispatchQueuedMsg_MsgDispatcher_MSG(ythis, _thCxt);
      os_delayThread(500);
    }
  }
  STACKTRC_LEAVE; return 0;
}



/**Implementation of startSystem method defined in fw_LogStateDispatcher.h */
int startSystem_MsgDispatcher_MSG(MsgDispatcher_MSG_s* ythis, int prioThread)
{
  STACKTRC_ENTRY("startSystem_MsgDispatcher_MSGF");
  
  { OS_HandleThread hThread;
    int osError = os_createThread(&hThread, run_MsgDispatcher_MSG, ythis, "msgDispatcher", prioThread, 0);
    ASSERT(osError==0);
    os_delayThread(100);  //wait a little to give the thread a chance to start.
  }
  return 1;
}




