/************************************************************************************************
 * Copyright/Copyleft:
 *
 * For this source the LGPL Lesser General Public License,
 * published by the Free Software Foundation is valid.
 * It means:
 * 1) You can use this source without any restriction for any desired purpose.
 * 2) You can redistribute copies of this source to everybody.
 * 3) Every user of this source, also the user of redistribute copies
 *    with or without payment, must accept this license for further using.
 * 4) But the LPGL ist not appropriate for a whole software product,
 *    if this source is only a part of them. It means, the user
 *    must publish this part of source,
 *    but don't need to publish the whole source of the own product.
 * 5) You can study and modify (improve) this source
 *    for own using or for redistribution, but you have to license the
 *    modified sources likewise under this LGPL Lesser General Public License.
 *    You mustn't delete this Copyright/Copyleft inscription in this source file.
 *
 * This source may be used also with another licence, if the author 
 * and all other here named co-authors have agreed to this contract.
 * Especially a company can use a copy of this sources in its products without publishing.
 * The user should have a underwritten contract therefore.
 *
 * @author Hartmut Schorrig, Germany, Pinzberg, www.vishia.org
 *
 **copyright***************************************************************************************
 *
 * @content
 *
 * @author Hartmut Schorrig, Pinzberg, Germany
 *
 * @version 0.83
 **This file is referenced to the java2c-translated MsgDispatcher_MSG.h/c */
#include "VaArgBuffer.h"
#include "Fwc/fw_Exception.h"
#include <string.h>


VaArgBuffer* ctor_VaArgBuffer(MemC mthis, int size, ThCxt* _thCxt)
{ VaArgBuffer* ythis = PTR_MemC(mthis, VaArgBuffer);
  STACKTRC_TENTRY("ctor_VaArgBuffer");
  checkSize_MemC(mthis, sizeof(VaArgBuffer), _thCxt);
  clean_VaArgBuffer(ythis, _thCxt);
  STACKTRC_LEAVE; return ythis;
}

void copyFrom_VaArgBuffer(VaArgBuffer* ythis, va_list src, ThCxt* _thCxt)
{
  ythis->data = va_arg(src, VaArgBuffer_Data_s);
  //memcpy(ythis->v, src->v, sizeof(ythis->v));
}


va_list get_va_list_VaArgBuffer(VaArgBuffer* ythis, ThCxt* _thCxt)
{ va_list args;
  //GNU-CC: error, va_start(args, ythis->sType);
  args = (va_list)(ythis->data.v);  //simple & easy, va_list is a pointer to the poor values.
  return args;
}


void clean_VaArgBuffer(VaArgBuffer* ythis, ThCxt* _thCxt)
{
  memset(&ythis->data, 0, sizeof(ythis->data));
}



