/**************************************************************************
 * This file is generated by Java2C
 **copyright***************************************************************
 *************************************************************************/
#ifndef __MainController_h__
#define __MainController_h__

#include "Jc/ObjectJc.h"

#include "Fwc/fw_Exception.h"   //basic concept

#include "ExampleAllReferences.h"
#include "LogMessageFile_MSG.h"  //embedded type in class data
#include "PID_controller.h"  //embedded type in class data
#include "ReadTargetFromText.h"  //embedded type in class data
#include "TestArrayExamples.h"  //embedded type in class data


/*@CLASS_C MainController @@@@@@@@@@@@@@@@@@@@@@@@*/

typedef struct MainController_t
{ ObjectJc object;
  struct LogMessageFW_t* msg; /*j2c:**/  /*The message interface. It is public to enable static access via MainController.singleton. */
  struct MsgDispatcher_MSG_t* msgDispatcher; /*j2c:**/  /*The message interface. It is public to enable static access via MainController.singleton. */
  LogMessageFile_MSG_s logMsgFileCtrlValues; /*j2c:$*/  /*The message interface. It is public to enable static access via MainController.singleton. */
  LogMessageFile_MSG_s logMsgFileGC; /*j2c:$*/  /*The message interface. It is public to enable static access via MainController.singleton. */
  struct WaySensor_t* way1Sensor; /*j2c:**/  /*Aggregation to a way sensor for input for control. */
  struct WaySensor_t* way2Sensor; /*j2c:**/  /*Aggregation to a way sensor for input for control. */
  struct WayActuator_t* way1Actuator; /*j2c:**/  /*Aggregation to a way actuator, servomotor or such, output for control. */
  struct WayActuator_t* way2Actuator; /*j2c:**/  /*Aggregation to a way actuator, servomotor or such, output for control. */
  int16 wWay; /*j2c:%*/  /*The set value for the way in 0.1mm-units from above -3 m to 3 m. */
  int32 dWay; /*j2c:%*/  /*controller offset (deviation). */
  int16 addWay; /*j2c:%*/  /*Simple set value generator as first example: add 0.5 mm per step in cycle time. */
  struct SetValueGenerator_t* mySetValueGenerator; /*j2c:**/  /*A Set value generator used hence second example using new. */
  int16 yOut; /*j2c:%*/  /*The actuating variable for the movement. It is a voltage for a motor in range -10000 to 10000, unit milliVolt. */
  PID_controller_s pidCtrl1; /*j2c:$*/  /*The PID controller.*/
  ReadTargetFromText_s targetReader; /*j2c:$*/  /*This class helps to read target positions and its velocity from a text file. */
  TestifcREF testifc; /*j2c:@*/  /*A interface reference to test.*/
  TestClassREF testDynamicReference; /*j2c:@*/  /*A reference to test the garbage collection.*/
  struct TestClassFinal_t* testStaticReference; /*j2c:**/  /*A reference to test which references need not 2 values.*/
  TestArrayExamples_s testArrayExamples; /*j2c:$*/  /*A reference to test which references need not 2 values.*/
} MainController_s;
  

typedef struct MainController_Y_t { ObjectJc object; int32 length; int16 sizeElement; int16 mode; MainController_s data[50]; } *MainController_Y;

extern struct ClassJc_t const reflection_MainController_s;
  

  extern MainControllerREF singleton_MainController; /*j2c:@*/  /*The MainController is a singelton, the constructor is private. */

/**Sends test messages, to test the message dispatcher.*/
METHOD_C MainController_s* ctorO_MainController(ObjectJc* yObj, struct iRequireMainController_t* broker /*j2c:**/, struct LogMessageFW_t* msg1 /*j2c:**/, struct TestClassFinal_t* testStaticReference /*j2c:**/, ThCxt* _thCxt);



void finalize_MainController(ObjectJc* yObj, ThCxt* _thCxt);

/**Gets the set value in units mm*/
METHOD_C int16 getWaySetvalue_MainController(MainController_s* ythis, ThCxt* _thCxt);

/**Gets the offset of the controller on input*/
METHOD_C int32 getWayOffset_MainController(MainController_s* ythis, ThCxt* _thCxt);

/**prepares the working of the controller, called on startup from outside.*/
METHOD_C void startup_MainController(MainController_s* ythis, ThCxt* _thCxt);

/**This is the cyclical called method to execute the controlling. It is called from outside. */
METHOD_C void step_MainController(MainController_s* ythis, ThCxt* _thCxt);

/**Get the internal value of the integrator of the first way controller. */
METHOD_C float getWay11Intg_MainController(MainController_s* ythis, ThCxt* _thCxt);

/**stores a next target point*/
METHOD_C bool setTarget_MainController(MainController_s* ythis, int16 targetValue /*j2c:%*/, ThCxt* _thCxt);



/*@CLASS_C TestSuper @@@@@@@@@@@@@@@@@@@@@@@@*/

typedef struct TestSuper_t
{ ObjectJc object;
  int32 b; /*j2c:%*/
} TestSuper_s;
  

typedef struct TestSuper_Y_t { ObjectJc object; int32 length; int16 sizeElement; int16 mode; TestSuper_s data[50]; } *TestSuper_Y;

extern struct ClassJc_t const reflection_TestSuper_s;
  


METHOD_C TestSuper_s* ctorO_TestSuper(ObjectJc* yObj, int32 a /*j2c:%*/, ThCxt* _thCxt);



void finalize_TestSuper(ObjectJc* yObj, ThCxt* _thCxt);

#endif //__MainController_h__
