package org.vishia.bridgeC;

import java.util.Collection;


//import java.util.concurrent.ConcurrentLinkedQueue;
/**This version of ConcurrentLinkedQueue inherites the original java.util.concurrent.ConcurrentLinkedQueue 
 * without any other extensions or overload methods,
 * but it has special constructors, which are oriented to a C-language implementation for embedded systemss
 * with a static memory allocation. In Java the special constructor functions were dummies.
 */
public class ConcurrentLinkedQueue<EntryType> extends java.util.concurrent.ConcurrentLinkedQueue<EntryType>
{
  private static final long serialVersionUID = 8639030493898499627L;

  /**Same as original:
   * Creates a <tt>ConcurrentLinkedQueue</tt> that is initially empty.
   */
  public ConcurrentLinkedQueue() {}

  /**Same as original:
   * Creates a <tt>ConcurrentLinkedQueue</tt>
   * initially containing the elements of the given collection,
   * added in traversal order of the collection's iterator.
   * @param c the collection of elements to initially contain
   * @throws NullPointerException if the specified collection or any
   *         of its elements are null
   */
  public ConcurrentLinkedQueue(Collection<? extends EntryType> c) 
  { super(c);
  }

  /**Creates an empty LinkedQueue,
   * but with memory to save nodes.
   * Additional for C-Using in embedded systems. 
   */
  public ConcurrentLinkedQueue(MemC memNodes)
  { //ignore the sharing in Java implementation!
    super();
  }
  
  /**Additional for C-Using in embedded systems: Creates an empty LinkedQueue,
   * but with shared nodes with another LinkedQueue
   */
  public ConcurrentLinkedQueue(ConcurrentLinkedQueue<EntryType> srcNodeShare)
  { //ignore the sharing in Java implementation!
    super();
  }
  
}
