package org.vishia.util;

import org.vishia.util.FileWriter;
import java.io.IOException;
import java.text.FieldPosition;
import java.text.SimpleDateFormat;
import java.util.Formatter;

import org.vishia.bridgeC.OS_TimeStamp;
import org.vishia.bridgeC.Va_list;

public class LogMessageFile extends LogMessage
{

  /**@java2c=fixStringBuffer. */
  final StringBuffer sFilenameBuffer = new StringBuffer(120);
  
  /**@java2c=fixStringBuffer. */
  final StringBuffer sDateformatBuffer = new StringBuffer(32);
  
  String sFormatTimestampFilename;
  
  final SimpleDateFormat formatTimestamp = new SimpleDateFormat();
  
  final FieldPosition formatField = new FieldPosition(SimpleDateFormat.DATE_FIELD);
  
  /** xxxjava2c=simpleArray. */
  final char[] charsFormatTimestampFilename = new char[32];
  
  //final StringBuilder charsFormatTimestampFilename = new StringBuilder(32); 
  
  int posTimestampInFilename;
  
  final FileWriter file = new FileWriter();
  
  OS_TimeStamp timeFileOpen;
  
  int dbgCntWriteError;
  
  int dbgCntOpenFailed;
  
  final private SimpleDateFormat dateFormat = new SimpleDateFormat("MMM-dd HH:mm:ss.SSS: ");
  
  //final char[] buffer = new char[1000];
  
  final private StringBuilder sBuffer = new StringBuilder(1000);
  
  public LogMessageFile
  ( String sFilename
  , int nrofSecondsToFlush
  , int nrofHoursPerFile
  )
  { String sTimestampInFilename;
    final int pos2TimestampInFilename;
    posTimestampInFilename = sFilename.indexOf('$');
    if(posTimestampInFilename >=0)
    { pos2TimestampInFilename = sFilename.indexOf('$', posTimestampInFilename+1);
      if(pos2TimestampInFilename >0)
      { sTimestampInFilename = sFilename.substring(this.posTimestampInFilename+1, pos2TimestampInFilename);
        int nrofCharsTimestampInFilename = sTimestampInFilename.length();
        /*Store the format String localy in this class. It's not depend from outside memory management. */
        sTimestampInFilename.getChars(0, nrofCharsTimestampInFilename, charsFormatTimestampFilename, 0);
        //charsFormatTimestampFilename.append(sTimestampInFilename);
        /*Represent the StringBuilder with a String. */
        //sFormatTimestampFilename = charsFormatTimestampFilename.toString();
        sFormatTimestampFilename = new String(charsFormatTimestampFilename, 0, nrofCharsTimestampInFilename);
        //copyToBuffer_StringJc(sTimestampInFilename, ythis->charsFormatTimestampFilename, sizeof(ythis->charsFormatTimestampFilename)); 
        this.sFilenameBuffer.append(sFilename.substring(0, this.posTimestampInFilename));
      }
      else throw new IllegalArgumentException("second $ to delimit timestamp in filename missing."); //, this.posTimestampInFilename);
    }
    else
    { //no timestamp in filename given, use default: Timestamp on start of filename.
      this.posTimestampInFilename = 0;
      pos2TimestampInFilename = -1;  //postfix of filename starts at 0
      sFormatTimestampFilename = "MMdd_HHmm"; 
    }
    this.formatTimestamp.applyPattern(sFormatTimestampFilename);
    this.sFilenameBuffer.append(sFormatTimestampFilename);
    this.sFilenameBuffer.append(sFilename.substring(pos2TimestampInFilename+1));
  }
  
  
  
  
  
  @Override
  public void sendMsgVaList(int identNumber, OS_TimeStamp creationTime, String text, Va_list args)
  {
    // TODO Auto-generated method stub

    if(this.file.isOpen())
    { //file is opened
      OS_TimeStamp timeTestClose;
      int secDiff;
      timeTestClose = OS_TimeStamp.os_getDateTime();
      secDiff = timeTestClose.time_sec - this.timeFileOpen.time_sec;
      if(secDiff >= 3600)
      { if(this.file.isOpen())
        { //printf("\nclose log-file\n");
          try{ file.close(); }
          catch(IOException exc){  }
        }
      }
    }
    if(!this.file.isOpen())
    { //file open because data are to write:
      this.timeFileOpen = OS_TimeStamp.os_getDateTime();
      formatTimestamp.format(this.timeFileOpen, sDateformatBuffer, formatField);
      String sTimeFileOpen = sDateformatBuffer.toString();
      sFilenameBuffer.replace(posTimestampInFilename, posTimestampInFilename + sTimeFileOpen.length(), sTimeFileOpen);
      boolean bOk = this.file.open(sFilenameBuffer.toString());
      if(!bOk)
      { dbgCntOpenFailed +=1;
      }
    }
    if(file.isOpen())
    { /**@java2c=stackInstance, fixStringBuffer. */
      final StringBuilder bufferFormat = new StringBuilder(1000);
      /**@java2c=stackInstance. */
      final Formatter formatter = new Formatter(bufferFormat);
      formatter.format(text, args.get());
      /**@java2c=stackInstance, fixStringBuffer. */
      final StringBuffer bufferTimestamp = new StringBuffer(30);
      dateFormat.format(creationTime, bufferTimestamp, formatField);
      sBuffer.setLength(0);
      sBuffer.append(bufferTimestamp)
             .append("; ")   //hint: use semicolon to view the data with ms-excel in csv-format.
             .append(identNumber)
             .append("; ")
             .append(bufferFormat)
             //.append(String.format(text,args.buffer.get()))
             .append("\r\n")
             ;
      try
      { file.write(sBuffer.toString());
        file.flush();
      }    
      catch(IOException exc){ dbgCntWriteError +=1; }
    }
    
    
    
  }

  
  
  
  
  
  
}
